'From Squeak3.9 of 7 November 2006 [latest update: #7067] on 18 December 2008 at 8:09:07 pm'!

!Character methodsFor: '*emailparser-model' stamp: 'SLB 12/18/2008 17:40'!
isEmailDateTimeSeparator
	"Answer whether the receiver is one of the separator characters used
	within rfc822(ish) email date and time strings -- space, period, slash, or comma.
	SLB 12/18/2008"

	value = 32 ifTrue: [^true].	"space"
	value = 58 ifTrue: [^true].	"colon"
	value = 44 ifTrue: [^true].	"comma"
	value = 45 ifTrue: [^true].	"dash or hyphen"
	value = 46 ifTrue: [^true].	"period"
	value = 47 ifTrue: [^true].	"slash"
	^false! !

!Character methodsFor: '*emailparser-model' stamp: 'SLB 4/2/2008 14:35'!
isWhitespace
	"Answer whether the receiver is space or tab. SLB 4/24/2007 10:30"
	
	value = 32 ifTrue: [^true].	"space"
	value = 9 ifTrue: [^true].	"tab"
	^false! !


!Stream methodsFor: '*emailparser-model' stamp: 'SLB 4/2/2008 14:37'!
isExternalStream
	"needed for email parsing model"
	
	^false! !


!PositionableStream methodsFor: '*emailparser-model' stamp: 'SLB 12/18/2008 17:37'!
skipEmailDateTimeSeparators
	"For parsing email dates.  RFC822-legal date fields (day month year) are separated
	 by spaces.  However rogue email clients somethimes use slashes or dashes.  And
	 in times, where they should use a colon, they sometimes use periods.  SLB 12/18/2008"
	
	[self atEnd]
		whileFalse:
			[self next isEmailDateTimeSeparator ifFalse: [^ self position: self position-1]]! !


!FileStream methodsFor: '*emailparser-model' stamp: 'SLB 4/2/2008 14:39'!
isExternalStream
	"yes I am"
	
	^true! !


!FileStream reorganize!
('accessing' contents contentsOfEntireFile directoryEntry mimeTypes next next: nextPut: nextPutAll: size)
('converting' asBinaryOrTextStream)
('editing' edit viewGZipContents)
('file accessing' asUrl file localName name)
('file modes' ascii binary readOnly readOnlyStream readWrite text)
('file open/close' close closed flush reopen)
('fileIn/Out' fileIn fileInObjectAndCode fileIntoNewChangeSet)
('positioning' position position: reset setToEnd skip: truncate:)
('printing' longPrintOn: longPrintOn:limitedTo:indent: printOn:)
('remote file compatibility' dataIsValid)
('testing' atEnd)
('*MorphicExtras-file accessing' url)
('*emailparser-model' isExternalStream)
('*network-uri' uri)
!

PositionableStream removeSelector: #skipEmailDateSeparators!

!PositionableStream reorganize!
('accessing' back contents contentsOfEntireFile last nextDelimited: nextInto: nextInto:startingAt: nextLine nextWordsInto: next: next:into: next:into:startingAt: next:putAll: next:putAll:startingAt: originalContents peek peekBack peekFor: upToAll: upToEnd upTo:)
('converting' asBinaryOrTextStream asZLibReadStream)
('data get/put' boolean boolean: int16 int16: int32 int32: string string: uint16 uint16: uint24 uint24: uint32 uint32:)
('fileIn/Out' backChunk basicNextChunk checkForPreamble: command: copyMethodChunkFrom: copyMethodChunkFrom:at: copyPreamble:from:at: decodeString:andRuns: decodeStyle:version: fileIn fileInAnnouncing: fileInFor:announcing: fileInSilentlyAnnouncing: header nextChunk nextChunkText parseLangTagFor: skipSeparators skipSeparatorsAndPeekNext skipStyleChunk trailer unCommand verbatim:)
('nonhomogeneous accessing' nextInt32 nextInt32Put: nextLittleEndianNumber: nextLittleEndianNumber:put: nextNumber: nextNumber:put: nextString nextStringOld nextStringPut: nextWord nextWordPut:)
('positioning' backUpTo: match: padToNextLongPut: padTo:put: position positionOfSubCollection: positionOfSubCollection:ifAbsent: position: pushBack: reset resetContents setToEnd skipTo: skip: untilEndWithFork:displayingProgress:)
('testing' atEnd isBinary isEmpty)
('*packageinfo-base' untilEnd:displayingProgress:)
('private' on: positionError setFrom:to:)
('*seaside2-squeak' asMIMEDocument asMIMEDocumentType: upToAndSkipThroughAll:)
('*emailparser-model' skipEmailDateTimeSeparators)
!


!Stream reorganize!
('accessing' basicNext basicNextPut: basicNextPutAll: binary contents flush localName next next: next:put: nextMatchAll: nextMatchFor: nextPut: nextPutAll: openReadOnly printOn: readOnly upToEnd)
('alternate syntax' dialect withStyleFor:do:)
('as yet unclassified' sleep)
('enumerating' do:)
('file open/close' close)
('filter streaming' write:)
('printing' print: printHtml:)
('testing' atEnd closed isStream isTypeHTTP nextWordsPutAll:)
('*monticello' isMessageStream)
('*KomHttpServer' asHttpResponseTo: isTranscriptStream mimeType)
('*scriptaculous' arguments: javascript:)
('*emailparser-model' isExternalStream)
!

Character removeSelector: #isEmailDateSeparator!

!Character reorganize!
('accessing' asciiValue charCode codePoint digitValue leadingChar)
('comparing' < = > hash sameAs:)
('converting' asCharacter asIRCLowercase asInteger asLowercase asString asSymbol asText asUnicode asUnicodeChar asUppercase basicSqueakToIso isoToSqueak macToSqueak squeakToIso squeakToMac to:)
('copying' clone copy deepCopy veryDeepCopyWith:)
('object fileIn' comeFullyUpOnReload: objectForDataStream:)
('printing' hex isLiteral printOn: printOnStream: storeBinaryOn: storeOn:)
('testing' canBeGlobalVarInitial canBeNonGlobalVarInitial isAlphaNumeric isCharacter isDigit isLetter isLowercase isOctetCharacter isSafeForHTTP isSeparator isSpecial isTraditionalDomestic isUppercase isVowel tokenish)
('*packageinfo-base' escapeEntities)
('private' setValue:)
('*scriptaculous' javascriptOn:)
('*emailparser-model' isEmailDateTimeSeparator isWhitespace)
!


