﻿Object subclass: #EmailParserExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EmailParser-TestExamples'!
!EmailParserExamples commentStamp: 'RF 2/22/2009 14:35' prior: 0!
The email parser code was developed as part of the Collaborative Electronic Records Project (CERP), see http://siarchives.si.edu/cerp/.  This code is distributed as Open Source Software under the Squeak license  (http://www.squeak.org/SqueakLicense/)  and the MIT license  (http://www.opensource.org/licenses/mit-license.php).  10/22/2008


The MIT license follows:

Copyright (c) 2008 Rockefeller Archive Center
Copyright (c) 2008 Smithsonian Institution Archives

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


The EmailParserExamples class contains a bunch of class methods that create instances of Messages with various complicated structures and/or erroneous structures for testing the parser.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

EmailParserExamples class
	instanceVariableNames: ''!

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 15:07'!
exampleDifficultChildMessage1
	"Not sure yet why this is a problem"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleDifficultChildMessage1)"

	^(ReadWriteStream with:
'From: "Crichton, Fred" <CrichtonC@dk.com>
Sender: "Crichton, Fred" <CrichtonC@dk.com>
To: "Bart, Black"
Subject: RE: Fwd: bus audit
Date: Wed, 2 Mar 2001 14:22:37 -0400
Message-ID: <F5E4E8268C8B4146A0CCD5E10FC2A1038CF6BE@ECL02.US.SINET.EDU>
MIME-Version: 1.0
Content-Type: multipart/mixed;
	boundary="----=_NextPart_000_0D1B_01C7BD8A.0E814D80"
X-Mailer: Microsoft Office Outlook 11

This is a multi-part message in MIME format.

------=_NextPart_000_0D1B_01C7BD8A.0E814D80
Content-Type: multipart/alternative;
	boundary="----=_NextPart_001_0D1C_01C7BD8A.0E814D80"


------=_NextPart_001_0D1C_01C7BD8A.0E814D80
Content-Type: text/plain;
	charset="Windows-1252"
Content-Transfer-Encoding: 7bit

Black,

    FYI.  Fred

------=_NextPart_001_0D1C_01C7BD8A.0E814D80
Content-Type: text/html;
	charset="Windows-1252"
Content-Transfer-Encoding: quoted-printable

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
charset=3DWindows-1252">
<TITLE>RE: Fwd: bus audit</TITLE>
</HEAD>
<BODY>
<!!-- Converted from text/plain format -->

<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp; FYI.&nbsp; Fred</FONT>
</P>

</BODY>
</HTML>
------=_NextPart_001_0D1C_01C7BD8A.0E814D80--

------=_NextPart_000_0D1B_01C7BD8A.0E814D80
Content-Type: message/rfc822
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment

From: "Henry, Paul A" <thenry@band.com>
To: "Deville, Jane",
	"Crichton, Fred"
Cc: <jcoreman@band.com>
Subject: RE: Fwd: bus audit
Date: Wed, 2 Mar 2001 11:54:13 -0400
MIME-Version: 1.0
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_0D17_01C7BD8A.0E814D80"
X-Mailer: Microsoft Office Outlook 11

This is a multi-part message in MIME format.

------=_NextPart_000_0D17_01C7BD8A.0E814D80
Content-Type: text/plain;
	charset="Windows-1252"
Content-Transfer-Encoding: 7bit

Jane/Fred - I will get the revised bid and the three year fee to you
by
Friday.  Sorry for the delay.

Paul A. Henry


-----Original Message-----
From: Jane Deville [mailto:DevilleJ@dk.com]
Sent: Wednesday, March 02, 2001 10:44 AM
To: Henry, Paul A; Fred Crichton
Cc: Kelly, John J; Sue Robinson; Black Bart; Elizabeth Seconde
Subject: RE: Fwd: bus audit



Sent: Tuesday, February 15, 2001 11:08 AM
To: Henry, Paul A; Jane Deville
Cc: Sue Robinson; Black Bart; Elizabeth Seconde
Subject: Re: Fwd: bus audit

>>> Jane Deville 02/10/05 04:30PM >>>
Tim and others,

Just wanted to follow up to see if there is any news on the attached.

Thanks for your continued attention to this matter.


Jane Benson Deville
Contract Negotiator - Attorney
Jrandom Institution, Office of Contracting
Washington, D.C.  20560-0907

------=_NextPart_000_0D17_01C7BD8A.0E814D80
Content-Type: text/html;
	charset="Windows-1252"
Content-Transfer-Encoding: quoted-printable

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
charset=3DWindows-1252">
<META NAME=3D"Generator" CONTENT=3D"MS Exchange Server version =
6.5.7036.0">
<TITLE>RE: Fwd: bus audit</TITLE>
</HEAD>
<BODY>
<!!-- Converted from text/plain format -->

<P><FONT SIZE=3D2>Jane/Fred - I will get the revised bid and the three =
year fee to you by ... blah blah blah</FONT>

<BR>

</BODY>
</HTML>
------=_NextPart_000_0D17_01C7BD8A.0E814D80--

------=_NextPart_000_0D1B_01C7BD8A.0E814D80--
') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 15:14'!
exampleEstivanMessageWithAttach1
	"This message has a multipart/appledouble and some empty attachment parts.
	 Note: the large attachment has been severely shortened, And the ending boundary
	 of that attachment doesn't begin with '--' which is illegal but common."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleEstivanMessageWithAttach1)"

	^(ReadWriteStream with:
'From estivan@soundit.com Mon, 1 Jul 2002 11:33:00 +0200
Date: Mon, 1 Jul 2002 11:33:00 +0200
From: Estivan Borge estivan@soundit.com
Subject: [CsndTek] better bell sounds

------------25E521C131EC7EB
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit

Now here is a collection of simple bell sounds using various synthesis
techniques including additive and FM. Some experimenting with the
parameters is recommended, and also most instruments sound best in
a particular pitch range which you can find by playing them using
a MIDI keyboard, or this simple keyboard emulator
  http://soundit.com/estivan/html/keyboard.html
There are two orc/sco pairs: one is score based (bells.orc, bells.sco),
and the other uses MIDI (bells_m.orc bells_m.sco). Two include files
needed for compilation are also attached.
------------25E521C131EC7EB
Content-Type: application/x-zip-compressed; name="include.zip"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="include.zip"
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------------25E521C131EC7EB
Content-Type: application/x-zip-compressed; name="bells.zip"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="bells.zip"

UEsDBBQAAgAIAKA44SzP8dr+dwQAAHAPAAAJAAAAYmVsbHMub3Jj1VbbbttGEH0mv2KQBpDkKPRe
ZcluUULB3Ce7QdO+FTDWEmUvTJEyd+04f9/ZCyVKpmj1LTUMkZw5Ozs7lzNr6uQXADElhKQPZrU2
7pOztJzfl4X/oGn6ky7nxdMih3e3yuQ3KzWvK5PdZ1U9f9dSLu/yspGmd/rW6pUzQDKZJMkFzKvS
WFVa92Lrqih0eQd5+ZwX1ToHBOcmTbVdrZOlRUtAx0DGIMhsMgaKb7StZC3lR68du428lGRkwmQb
zffRcUHziyv43kvrE+CfFE8A4Y+Md//3Vuxrxe6Z4t4TPhX7rrRfdoVxa+9F0onoFv64a9L0/eXv
n69vKJsOCzpgcjJw2RlQMqADU5+yUZqensDH+AcaS6cGeg6XV2C+l/Y+N9ps1SenaZpEDJr+enP9
x1+fv/z259WQZHSAKZJoT8/XhrmCdC9wAjyTXsZbMoqyVGFR0iR/WVe+CEMlo5JkzBcZImhSmbku
tNN7u6hmsQix9BTr0A8pfIChxE6DUy8codDv5Z50FJaniu+t5Y1C7Cmi3PvLEmwnk9/FkiRUeq37
x9ZT1qr5AyKJO+tQOXcUR3ect+5dOF+0Wq1bLg3dS/xuXGUY5+rJgiIuWMKxRprk5UKXXfli5+A9
LpStavim7T0U1be1MgaWurB53ZlB1plBVxGvwu6TgiflafqwXNaPybqqbaMRu6lDGEN/iaOiuHtD
Pt7yWtX5I+ZhHM41duuZj3tb57eJrX1GzlDCegtGjiP/4a6LfK6+H8xWYC/8OHMPLt/Oo6JHJg2f
s5CqkLu+nPFzMHq1LnLXal3p4QfTc7GTH3FGfKd3JU1kYhZOtKoWT6E8jL4rVeFapyuQPAYSY4DO
aesGjioXzskYVvbiFrqg7q2MoQ0Dwtl3ofMdwF5cU/kZh8+YZNE0l/NeZPjLcFfcJwb/VX82rc2I
72NvOPRUOOJ+C1xeNYngDbaVxO2DyjfaS5yDWiy01c/5G6QoDrfUwdLlMV70Feuwdv01hYftIAPH
0jafimw2la+ol06y2ewV+TLhRaLN0TQjlHqxbIs5eo+FeAH2qS6hWi4Bs2e1Kgyo28rFA2cI2ArU
c6UXoAqtDF430EGMtHdw6F2Fn2Fo6kAjI/gVKJwDGW2P0Y0KwoBEe2yDZD32elBBuLHHN0jeY68H
FYQbe2KDFD32elBBuLEnN0jZY68HFYQe2aovn5pQY9QTB2trWBykXsPbGr4dk60Z6Q8eNMJrZFsj
g0b6q0hg5K4eoNPYBIjgnYjA1gEhDs9g7MRnvCfXSL7j2PeRmGnG2rqhclSCpIA/wv3IhsW5B5MN
+ZMoFx2sH/lkcizpy51B/eGYKS0PUsr7T1++ssvrv6+GelkOXJjd/W4Ues83cfDOPNbW18dOFWAw
4wEaukErcbzTMN/JbgYmcbAHDNveAXZgYkPW03hXKPRK2zDQXczDamdrDLFYxfTI4d93+9qO7cNV
1NwSmjuC27Yh2EMT3VtrsuuATPbmeHLE5Xnyn65eZ8jN/4spTn6cKf4vUEsDBBQAAgAIAKA44SwE
R+4ilgQAAMUPAAALAAAAYmVsbHNfbS5vcmPVVktv4zYQPku/YrBdwHbWq/Dp2EmLoig2PSVd9HEr
EDC2nBCRJa+kZLP/vjMkZcmOrKS3rWGI5MxwOJzHN6zK6CcANWeMxQ/VZlvRUoo4X97nmVvwOP7B
5svscZXCu1tTpTcbsyyLKrlPinL5rsNc36V5Q43v7G1tN6SAJTqKogtYFnlVm7ymSV0WWWbzO0jz
pzQrtimgcFrFsa0322hdoybgU2BTUGwxmwLHGe8yRYf50XGndJCjsoTNhO5Ky0PpsKH54g55MOks
Af6J8Qbgf2y6/z/YcchV+3cKZ8/kXB2a0p3sE8PRzoqoV6Kf+P3uieP3l799ur7hYj7O+Ejo2Yii
M+JsxEdVeSomcRxtTFXZO5cIvF1h5EW7Qt/LdoU+Ve0Ks0G3Kwz9LI5PT+Bj+IHFfCyBn8PlFVTf
8vo+rWzVsk9O0YYgg/Ze3Vz//tenz7/8cTVmCR9h3DUaaZfbSlCW0wROQCba0WSHxpEWG8x0HqXP
28JdyJcHMlkiXOaiBI+KamkzS3ynF9kiZDbmsxE9/DGHDzDWWL5w6ogTJLqzaOQTvz028mCvbBjq
gBHozl4RYY1W6V3Ic8a149If69nUtVk+oCSju44NmWMkmkPW0lyRLdZsth2TxjQJ68ZUgX4uHmsw
jJylCIriKM1XNu+LlzgHZ3Fm6qKEr7a+h6z4usUow9pmdVr2RlD0RpDS7IXbXVA05VX8sF6XX6Jt
UdYNR+2HDsUE2ssI38LpDaI5zVtTpl8wDlN/ryntF87vXZ47JuDFGTvjlOFDCaOnAVTx1FW6NN+O
RstDIi7OaJD69Tga/sag4bjwofKxG4qZPIfKbrZZSqXWFx55NDwXe/FRZ8zBR1/QVKIW/kabYvXo
04Mq32RUOn2OlMGR6AM0ztbUxUy+IiODW8UzbSSnHuwMrvVdh/ST61wFiGcqKtc4cQxBVk1xkfUq
wa/AU/Gc4PwX9dmUtmCujp1iX1P+ioclcHnVBEI2sp0gtgPXr5SXOgezWtnaPqWvgKI6XlJHU1cG
f/EXqCO6+dckHpaD9hjLu3iqksVcv4BePksWixfgK5QjqS5G84Rx7si6S5ZoPSbiBdSPZQ7Feg0Y
vdqarAJzW5A/sDFBXYB5KuwKTGZNhW8YNBA97QwcO1PhRxhXpYeRCfwMHM6BTdpr9Et5opdEfWIn
KQb0DUh54k6f3EnKAX0DUp6406d2kmpA34CUJ+706Z2kHtA3IOWJTrKTXy40PsfcM6Jtos7JoZE6
juxyZNsmOz3SXdxzlOPoLkd7jnbvG4/IfTXA56EIUEL2Sni09hLqeA/GSnzCx3eJ4DsNdR+AmSei
yxsbghIEBfwo+ugGxaUTZjvwZ4GuelA/4MnsraCv9xr1h7d0aX0UUt7/+vlPcXn999XYrvMRuZke
jRNfe66IvXXVl7J2+bGXBejMcIEGblBLaO/c93e2H4FZaOxeRrRvgD0xtQPreXgrZHZja9/Qyed+
N+maQkhWNX9j8x96fbVt+3gWNa+E5o1AxzYAe6yjO21NdElQ6MEYz97weJ79p6fXGWLz/6KLs++n
i/8LUEsDBBQAAgAIAKA44SzY6pgCdQAAAFcBAAAJAAAAYmVsbHMuc2NvXdBBDoUwCEXROat4KzCF
1pYuyIFz95//rOYbmDUn0JsgFwrUisgJBd9lmxiNNB7RJa6fGHQr8L6EZEBbQ93eIcr+yPykr7X3
a1IFPNYoM9YqtKTaPRxrlBprlJZqO7THGmXEGsVTrcPSSSjpJJT7JP5fO0R+UEsDBBQAAgAIAKA4
4SykKSJJHQAAAB4AAAALAAAAYmVsbHNfbS5zY2/jKlEwUDA0MuDiSgMyjM0MDBSMFHSNFIACqVxc
AFBLAQIXAxQAAgAIAKA44SzP8dr+dwQAAHAPAAAJAAAAAAAAAAEAAACkgQAAAABiZWxscy5vcmNQ
SwECFwMUAAIACACgOOEsBEfuIpYEAADFDwAACwAAAAAAAAABAAAApIGeBAAAYmVsbHNfbS5vcmNQ
SwECFwMUAAIACACgOOEs2OqYAnUAAABXAQAACQAAAAAAAAABAAAApIFdCQAAYmVsbHMuc2NvUEsB
AhcDFAACAAgAoDjhLKQpIkkdAAAAHgAAAAsAAAAAAAAAAQAAAKSB+QkAAGJlbGxzX20uc2NvUEsF
BgAAAAAEAAQA4AAAAD8KAAAAAA==

------------25E521C131EC7EB--




') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:15'!
exampleMultipartAlternativeMessage1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleMultipartAlternativeMessage1)"

	^(ReadWriteStream with:
'From:  Bert Nathaniel <bsn@bellcore.com> 
To: Nat Reed <nat@innosoft.com> 
Subject: Formatted text mail 
MIME-Version: 1.0 
Content-Type: multipart/alternative;
     boundary=boundary42 (a test ContentHeader comment)


--boundary42 
Content-Type: text/plain; charset=us-ascii 

...plain text version of message goes here.... 

--boundary42 
Content-Type: text/richtext 

.... richtext version of same message goes here ... 
--boundary42 
Content-Type: text/x-whatever 

.... fanciest formatted version of same  message  goes  here 
... 
--boundary42--') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:15'!
exampleMultipartAlternativeMessage2
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmaiilParserExamples exampleMultipartAlternativeMessage2)"

	^(ReadWriteStream with:
'From: Whomever 
Subject: whatever
MIME-Version: 1.0
Message-ID: id1@host.com 
Content-Type: multipart/alternative; boundary=42 
This example is from: http://www.w3.org/Protocols/rfc1341/7_3_Message.html

--42
Content-Type: message/external-body; 
    name="BodyFormats.ps"; 
    site="thumper.bellcore.com"; 
    access-type=ANON-FTP; 
    directory="pub"; 
    mode="image"; 
    expiration="Fri, 14 Jun 1991 19:13:14 -0400 (EDT)" 


Content-type: application/postscript 


--42 
Content-Type: message/external-body; 
     name="/u/nsb/writing/rfcs/RFC-XXXX.ps"; 
     site="thumper.bellcore.com"; 
     access-type=AFS 
     expiration="Fri, 14 Jun 1991 19:13:14 -0400 (EDT)" 


Content-type: application/postscript 


--42 
Content-Type: message/external-body; 
     access-type=mail-server 
     server="listserv@bogus.bitnet"; 
     expiration="Fri, 14 Jun 1991 19:13:14 -0400 (EDT)" 


Content-type: application/postscript 


get rfc-xxxx doc 


--42-- ') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:21'!
exampleMultipartAlternativeMessage3
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleMultipartAlternativeMessage3)"

	^(ReadWriteStream with:
'Return-Path: <rajpai@csa.abcd.ernet.in>
Delivered-To: rajpai@csa.abcd.ernet.in
Received: from deimos.csa.abcd.ernet.in (deimos.csa.abcd.ernet.in [144.16.67.57])
     by csa.abcd.ernet.in (Postfix) with ESMTP id 7F9B12B992
     for <rajpai@csa.abcd.ernet.in>; Fri, 14 Nov 2003 15:45:05 +0530 (IST)
Received: by deimos.csa.abcd.ernet.in (Postfix, from userid 9408)
     id EA8F24E659; Fri, 14 Nov 2003 16:03:59 +0530 (IST)
Received: from localhost (localhost [127.0.0.1])
     by deimos.csa.abcd.ernet.in (Postfix) with ESMTP id D57994A27C
     for <rajpai@csa.abcd.ernet.in>; Fri, 14 Nov 2003 16:03:59 +0530 (IST)
Date: Fri, 14 Nov 2003 16:03:59 +0530 (IST)
From: Raj Bhat <rajpai@csa.abcd.ernet.in>
To: Raj Bhat <rajpai@csa.abcd.ernet.in>
Subject: Testing
Message-ID: <Pine.LNX.4.58.0311141602430.11137@deimos.csa.abcd.ernet.in>
MIME-Version: 1.0
Content-Type: MULTIPART/MIXED; BOUNDARY="277887299-1503234992-1068806039=:11137"
Status: O
X-Status:
X-Keywords:
X-UID: 226

   This message is in MIME format. The first part should be readable text,
   while the remaining parts are likely unreadable without MIME-aware tools.
   Send mail to mime@docserver.cac.washington.edu for more info.

--277887299-1503234992-1068806039=:11137
Content-Type: TEXT/PLAIN; charset=US-ASCII

This is a test.
--277887299-1503234992-1068806039=:11137
Content-Type: IMAGE/jpeg; name="911c4s1_10x7.jpg"
Content-Transfer-Encoding: BASE64
Content-ID: <Pine.LNX.4.58.0311141603590.11137@deimos.csa.abcd.ernet.in>
Content-Description:
Content-Disposition: attachment; filename="911c4s1_10x7.jpg"

/9j/4AAQSkZJRgABAgAAZABkAAD/7AARRHVja3kAAQAEAAAAPAAA/+4ADkFk
b2JlAGTAAAAAAf/bAIQABgQEBAUEBgUFBgkGBQYJCwgGBggLDAoKCwoKDBAM
DAwMDAwQDA4PEA8ODBMTFBQTExwbGxscHx8fHx8fHx8fHwEHBwcNDA0YEBAY
GhURFRofHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8f
Hx8fHx8fHx8f/8AAEQgDAAQAAwERAAIRAQMRAf/EALEAAQADAAMBAQEAAAAA
*******some lines have been deleted for clarity******
SBPHq9oFkl6gJoASCLUQVKQE0AkCaAKASBPUBNUBJQIJKJQBgK8SCavpAmvD
vAmoCrAmvUA1ANQB9PAoVIFeJR//2Q==

--277887299-1503234992-1068806039=:11137
Content-Type: TEXT/plain; charset=US-ASCII; name="proxies.txt"
Content-Transfer-Encoding: BASE64
Content-ID: <Pine.LNX.4.58.0311141603591.11137@deimos.csa.abcd.ernet.in>
Content-Description:
Content-Disposition: attachment; filename="proxies.txt"

ZWNlIDogIDE0NC4xNi42NC40IDogICAgMzEyOA0Kc2VyYzogIDE0NC4xNi43
OS41ODoJMzEyOCAgIG9ubHkgYWZ0ZXIgNiBpbiB0aGUgZXZlbmluZyB0byA5
IGluIG1vcm5pbmcNCmNzYSA6ICAxNDQuMTYuNjcuOCA6CTgwODANCg==

--277887299-1503234992-1068806039=:11137-- ') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:21'!
exampleMultipartDigestMessage1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleMultipartDigestMessage1)"

	^(ReadWriteStream with:
'From: Moderator-Address 
MIME-Version: 1.0 
Subject:  Internet Digest, volume 42 
Content-Type: multipart/digest; 
     boundary="---- next message ----" 


------ next message ---- 

From: someone-else 
Subject: my opinion 

...body goes here ... 

------ next message ---- 

From: someone-else-again 
Subject: my different opinion 

... another body goes here... 

------ next message ------') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:22'!
exampleMultipartMixedMessage1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleMultipartMixedMessage1)"

	^(ReadWriteStream with:
'From: Nathaniel Borenstein <nsb@bellcore.com> 
To:  Ned Freed <ned@innosoft.com> 
Subject: Sample message 
MIME-Version: 1.0 
Content-type: multipart/mixed; boundary="simple boundary" 

This is the preamble.  It is to be ignored, though it 
is a handy place for mail composers to include an 
explanatory note to non-MIME compliant readers. 
--simple boundary 

This is implicitly typed plain ASCII text. 
It does NOT end with a linebreak. 
--simple boundary 
Content-type: text/plain; charset=us-ascii 

This is explicitly typed plain ASCII text. 
It DOES end with a linebreak. 

--simple boundary-- 
This is the epilogue.  It is also to be ignored.') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:25'!
exampleMultipartMixedMessage2
	"answer the message stream.  This is an elaboration of exampleMultipartMixedMessage1.
	 It includes an attachment copied from exampleNotesMultipartMessage1."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleMultipartMixedMessage2)"

	^(ReadWriteStream with:
'From: Nathaniel Borenstein <nsb@bellcore.com> 
To:  Ned Freed <ned@innosoft.com> 
Subject: Sample message 
Message-ID: <deamon.459.2178678399.75102.mockup@ru.edu>
MIME-Version: 1.0 
Content-type: multipart/mixed; boundary="simple boundary" 

This is the preamble.  It is to be ignored, though it 
is a handy place for mail composers to include an 
explanatory note to non-MIME compliant readers. 
--simple boundary 

This is implicitly typed plain ASCII text. 
It does NOT end with a linebreak. 
--simple boundary 
Content-type: text/plain; charset=us-ascii 

This is explicitly typed plain ASCII text. 
It DOES end with a linebreak. 

--simple boundary
Content-type: application/octet-stream; 
	name="smime.p7s"
Content-Disposition: attachment; filename="smime.p7s"
Content-transfer-encoding: base64
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--simple boundary-- 
This is the epilogue.  It is also to be ignored.') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:05'!
exampleMultipartRelated1
	"answer the message stream.  This example has strange html-like Content-Id: headers."
	"(RFC2822MIMEMessage  relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleMultipartRelated)"

	^(ReadWriteStream with:
'Return-Path: <nelsonj@mail.unc.edu>
Received: from [129.85.16.58] (nelsonj-mac.unc.edu [129.85.16.58])
	by mail.unc.edu (8.11.6/8.11.6) with ESMTP id f95H54s14415
	for <kellyc@mail.unc.edu>; Fri, 5 Oct 2001 13:05:05 -0400 (EDT)
Message-Id: <p05100308b7e3985f2af8@[129.85.16.58]>
X-Priority: 1 (Highest)
Date: Fri, 5 Oct 2001 13:04:52 -0400
To: kellyc@mail.unc.edu (Clem Kelly)
From: nelsonj@mail.unc.edu (Joseph Nelson)
Subject: Fwd: E-Clips No. 3: October 5, 2001
X-UIDL: 85="!!>3''!!!!G@*"!!X$G!!!!
Mime-Version: 1.0
Content-Type: multipart/Related; boundary="============_-1209820993==_mr============"
 ; type="text/html"

This is a multi-part message in MIME format.

--============_-1209820993==_mr============
--============_-1209820993==_mr============
Content-Type: text/html;

<!!doctype html public "-//W3C//DTD W3 HTML//EN">
<head><style type="text/css"><!!--
blockquote, dl, ul, ol, li { padding-top: 0 ; padding-bottom: 0 }
 --></style><title>Fwd: E-Clips No. 3: October 5,
2001</title></head><body>
<div>Clem,</div>
<div><br></div>
<div>Are you receiving these e-mails from FBR?</div>
<div><br></div>
<div>I think they''re free (they just started this week). They resemble
the dawn patrol, but they include links to the stories, which was a
shortcoming of the dawn patrol.</div>
<div><br></div>
<div>Joe</div>
<div>&nbsp;</div>
<div>&lt;&lt; start of forwarded material &gt;&gt;</div>
<div><br></div>
<div><br></div>
<div>Subject: E-Clips No. 3: October 5, 2001<br>
Date: Fri, 5 Oct 2001 12:53:25 -0400<br>
Thread-Topic: E-Clips No. 3: October 5, 2001<br>
Thread-Index: AcFNtwzl8j5zIz7KS9m5wX6LnFsXvwAAAqJQAAEtaeA=<br>
X-Priority: 1<br>
Priority: Urgent<br>
Importance: high<br>
From: &quot;Janice Hagstrom&quot; &lt;jhagstrom@nabr.org&gt;<br>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><font size="-1">&nbsp;</font></div>
<div><font size="-1"><br></font></div>
<div><img src="cid:p05100308b7e3985f2af8@[129.85.16.58].1.0"
width="576" height="65"></div>
<div><font size="-1" color="#FFFF00"><b>No. 3</b></font><br>
</div>
<div align="right"><font size="-1" color="#FFFF00"><b>October 5,
2001</b></font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080">The Foundation for Biomedical
Research is pleased to provide you with<i> Total E-Clips</i>, an
exciting new service for leaders in the biomedical research and health
care fields.</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080"><i>Total E-Clips</i>&nbsp; is a
complete news and information service containing a summary of the
day''s top stories as reported by the<i> New York Times</i>,<i> Wall
Street Journal</i> and other newspapers as well as other valuable
information being gathered from Websites and listservs.</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080">Should you have colleagues who
would like to be added to our distribution list, please let us know.
Likewise, if you wish to be removed from our mailing list, drop us a
line at</font> <a href="mailto:unsubscribe@fbresearch.org"><font
size="-1" color="#000080">unsubscribe@fbresearch.org</font></a><font
size="-1" color="#000080">.</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font size="-1" color="#000080">&nbsp;</font><br>
</div>
<div><font face="Verdana" color="#0000FF">&nbsp;</font><br>
</div>
<div><font face="Verdana" color="#0000FF">&nbsp;</font><br>
</div>
<div><br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
<x-tab>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
</x-tab>name=&quot;image001.gif&quot;<br>
Content-ID: &lt;image001.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image001.gif<br>
Content-Location: image001.gif<br>
<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
<x-tab>&nbsp; </x-tab>name=&quot;image002.gif&quot;<br>
Content-ID: &lt;image002.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image002.gif<br>
Content-Location: image002.gif<br>
<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
<x-tab>&nbsp; </x-tab>name=&quot;image003.gif&quot;</div>
<div>Content-ID: &lt;image003.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image003.gif<br>
Content-Location: image003.gif<br>
<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
<x-tab>&nbsp;&nbsp;&nbsp;&nbsp;
</x-tab>name=&quot;image004.gif&quot;<br>
Content-ID: &lt;image004.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image004.gif<br>
Content-Location: image004.gif</div>
<div><br></div>
<div>&lt;&lt; end of forwarded material &gt;&gt;</div>
</body>
</html>
--============_-1209820993==_mr============--') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:09'!
exampleNoBody1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples examplNoBody1)"

	^(ReadWriteStream with:
'From BCAnnounce@cd.edu Thu Sep 28 13:23:22 2006
Received: from BC-MSEGWCN-01.US.BCNET.BC.EDU ([170.101.49.81]) by BC-ECL01.US.BCNET.BC.EDU with Microsoft SMTPSVC(6.0.3790.1830);
	 Tue, 18 Apr 2006 09:23:27 -0400
Content-class: urn:content-classes:message
Subject: Event: Health Risk Assessment
MIME-Version: 1.0
Content-Type: application/ms-tnef;
	name="winmail.dat"
Content-Transfer-Encoding: binary
Date: Tue, 18 Apr 2006 09:19:00 -0400
Message-ID: <F2B84C1113AC74478DAB094CDF7FC9731AA9B8EA@BC-MSEGWCN-01.US.BCNET.BC.EDU>
X-MimeOLE: Produced By Microsoft Exchange V6.5
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: <F2B84C1113AC74478DAB094CDF7FC9731AA9B8EA@BC-MSEGWCN-01.US.BCNET.BC.EDU>
Thread-Topic: Event: Health Risk Assessment
Thread-Index: AcZi60BsnkMMVL4mSX66w4eIQ13BhQ==
From: "BC Email Announcements, BC Email Announcements" <BCAnnounce@cd.edu>
To: "ai&c.nsrc.*" <IMCEAGWISE-ai+26c+2Ensrc+2E+2A@cd.edu>,
	"ai&c.ofs.*" <IMCEAGWISE-ai+26c+2Eofs+2E+2A@cd.edu>,
	"ai&c.ogc.*" <IMCEAGWISE-ai+26c+2Eogc+2E+2A@cd.edu>,
	"AI&C.OIT.*" <IMCEAGWISE-AI+26C+2EOIT+2E+2A@cd.edu>,
	"ai&c.ops.*" <IMCEAGWISE-ai+26c+2Eops+2E+2A@cd.edu>,
	"ai&c.si.*" <IMCEAGWISE-ai+26c+2Esi+2E+2A@cd.edu>,
	"ai&c.soe.*" <IMCEAGWISE-ai+26c+2Esoe+2E+2A@cd.edu>,
	"ai&c.viarc.*" <IMCEAGWISE-ai+26c+2Eviarc+2E+2A@cd.edu>
Return-Path: BCAnnounce@cd.edu
X-OriginalArrivalTime: 18 Apr 2006 13:23:27.0407 (UTC) FILETIME=[46F70BF0:01C662EB]
Status: RO
X-Folder: Imported Mail
') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:16'!
exampleNotesMultipart1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleNotesMultipart1)"

	^(ReadWriteStream with: 'X-Account-Key: account2
X-UIDL: 1gJYuG4Jt3Nl3p20
X-Mozilla-Status: 0001
X-Mozilla-Status2: 10000000
Status:  U
Return-Path: <rfellows@ms.com>
Received: from e5.ny.ms.com ([32.97.182.145])
	by pickering.mail.mindspring.net (EarthLink SMTP Server) with ESMTP id 1gJYuA4Jt3Nl3p20
	for <whomever@mindspring.com>; Tue, 14 Nov 2006 08:38:24 -0500 (EST)
Received: from d01ml072.pok.ms.com (d01ml072.pok.ms.com [9.56.228.147])
	by d01av01.pok.ms.com (8.12.11.20060308/8.12.11) with ESMTP id kAEDc8ZR022015
	for <whomever@mindspring.com>; Tue, 14 Nov 2006 08:38:08 -0500
To: whomever@mindspring.com
MIME-Version: 1.0
Subject: Fw: Colloquium: Nicole Immorlica - Monday  November 20, 2006
X-Mailer: Lotus Notes Release 7.0 HF277 June 21, 2006
From: Ron Fellows <rfellows@ms.com>
X-MIMETrack: S/MIME Sign by Notes Client on Ron Fellows/Raleigh/IBM(Release 7.0 HF277|June
 21, 2006) at 11/14/2006 08:37:47 AM,
	Serialize by Notes Client on Ron Fellows/Raleigh/IBM(Release 7.0 HF277|June
 21, 2006) at 11/14/2006 08:37:47 AM,
	Serialize complete at 11/14/2006 08:37:47 AM,
	Itemize by Notes Client on Ron Fellows/Raleigh/IBM(Release 7.0 HF277|June 21, 2006) at
 11/14/2006 08:37:47 AM,
	S/MIME Sign failed at 11/14/2006 08:37:47 AM: Senders'' signing certificate
 is expired,
	S/MIME Sign by Notes Client on Ron Fellows/Raleigh/IBM(Release 7.0 HF277|June
 21, 2006) at 11/14/2006 08:38:03 AM,
	S/MIME Sign complete at 11/14/2006 08:38:03 AM,
	MIME-CD by Notes Server on D01ML072/01/M/IBM(Release 7.0.2 IGS702HF1|November
 11, 2006) at 11/14/2006 08:38:07,
	MIME-CD complete at 11/14/2006 08:38:07,
	Serialize by Router on D01ML072/01/M/IBM(Release 7.0.2 IGS702HF1|November
 11, 2006) at 11/14/2006 08:38:08
Message-ID: <OFE71903D9.906243B5-ON85257226.004AD90C-85257226.004AE506@ms.com>
Date: Tue, 14 Nov 2006 08:38:07 -0500
Content-type: multipart/mixed; 
	Boundary="0__=0ABBF8B5DFD95F9C8f9e8a93df938690918c0ABBF8B5DFD95F9C"
Content-Disposition: inline
X-ELNK-Info: spv=0;
X-ELNK-AV: 0
X-ELNK-Info: sbv=0; sbrc=.0; sbf=00; sbw=000;

--0__=0ABBF8B5DFD95F9C8f9e8a93df938690918c0ABBF8B5DFD95F9C
Content-type: text/plain; charset=ISO-8859-1
Content-transfer-encoding: quoted-printable




FYI
Regards,
Ron Fellows

CPT Strategic Architect
----- Forwarded by Ron Fellows on 11/14/2006 08:37 AM -----
|-----------------------------+----------------------------------------=
---|
|colloquia@cs.duke.edu        |                                        =
   |
|Sent by:                     |                                        =
   |
|owner-duke-talks@cs.duke.edu |                                        =
 To|
|                             |              announce@cs.duke.edu      =
   |
|11/13/2006 08:00 AM          |                                        =
 cc|
|                             |                                        =
   |
|                             |                                    Subj=
ect|
|                             |              Colloquium: Nicole Immorli=
ca |
|                             |              - Monday =A0November 20, 2=
006  |
|                             |                                        =
   |
|                             |                                        =
   |
|                             |                                        =
   |
|                             |                                        =
   |
|                             |                                        =
   |
|                             |                                        =
   |
|-----------------------------+----------------------------------------=
---|




Duke Computer Science Colloquia

Computing with Selfish Agents: Derandomization of Auctions
Nicole Immorlica
D106 LSRC, Duke
Monday =A0November 20, 2006
11:45AM - 12:45PM


Abstract

Many complex systems of our day involve autonomous agents
who act in their own self-interest. The goal in the field
of mechanism design is to define rules in the system such
that self-interested agents will collectively act in a way
that optimizes some system objective such as social welfare
or revenue. In this talk, I will first present an overview
of the basic notions of mechanism design. The focus of the
talk will be on a framework introduced by Goldberg et al.
for maximizing revenue in auctions for a good of unlimited
supply. Earlier work of Goldberg et al. introduced
randomized auction mechanisms that, in the worst case,
achieve close to the optimal revenue. We investigate the
feasibility of high revenue deterministic auctions. In the
process, we give an exponential-space construction for
converting any randomized auction to a deterministic one
with approximately the same revenue properties using
network flow techniques. We also present a polynomial-time
deterministic construction of an auction with good revenue
properties using parity arguments. =A0Our work bypasses an
impossibility result of Goldberg et al. for deterministic
symmetric auctions by introducing asymmetry into the
allocation and pricing scheme, suggesting that in this
setting asymmetry is essentially as powerful as randomness.


This talk is based on joint work with Gaggan Aggarwal, Amos
Fiat, Andrew Goldberg, Jason Hartline, and Madhu Sudan.

Biography

Nicole Immorlica is a postdoc in the Theory group at
Microsoft Research where she studies computational
economics and approximation algorithms with a focus on
problems encountered in the design of advertisement
auctions on search engines. =A0She graduated from the
Computer Science and Artificial Intelligence Laboratory
(CSAIL) at the Massachusetts Institute of Technology (MIT)
in Spring 2005 under the joint supervision of Prof. Erik
Demaine and Prof. David Karger. In her spare time, she
enjoys eating, hiking, and photography. =A0For more
information, please see her webpage at
http://research.microsoft.com/~nickle.
(See attached file: smime.p7s)=

--0__=0ABBF8B5DFD95F9C8f9e8a93df938690918c0ABBF8B5DFD95F9C
Content-type: application/octet-stream; 
	name="smime.p7s"
Content-Disposition: attachment; filename="smime.p7s"
Content-transfer-encoding: base64

MIAGCSqGSIb3DQEHAqCAMIIUOgIBATELMAkGBSsOAwIaBQAwCwYJKoZIhvcNAQcBoIISWjCCAtow
ggJDoAMCAQICAwMUtjANBgkqhkiG9w0BAQQFADBOMQswCQYDVQQGEwJVUzEQMA4GA1UEChMHRXF1
9w0DAgICAIAwCgYIKoZIhvcNAwcwDQYIKoZIhvcNAwICASgwDQYJKoZIhvcNAQEBBQAEgYBaUPjd
jjtkLBNwXEbAu5g6gNebF7cjJM22kb65r5OyJTfCaYL2AlCj3ZqfJoWIK2gStASRnwkzAmxJ1706
Uu1NzyoxM+1VKEg5Oqg1uD1T4Q99v5g/u9ZKGbgI2di94FMKVznakhJLNWFsVCBJk7nwAgJltTuV
ClIMgjdNG5pyOQAAAAA=

--0__=0ABBF8B5DFD95F9C8f9e8a93df938690918c0ABBF8B5DFD95F9C--

') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:40'!
exampleOutlookMessage1
	"answer a ReadWriteStream on the message string"
	"(RFC2822MIMEMessage new parseFromStream: EmailParserExamples exampleOutlookMessage1) inspect"

	^(ReadWriteStream with:
'Received: from SMTP server by Receiver SMTP version 1.0; 
Mon, 28 Oct 2002 08:42:42 -0500 (EST)
Message-ID: <006@example1.com>
From: "User1" <user1@example1.com> 
To: "User2" user2@example2.com> 
Subject: A test message to see if you can see me now!!
Date: Mon, 8 Nov 2002 13:46:54 +0100
MIME-Version: 1.0
Content-Type: multipart/mixed; 
	boundary="----=_NextPart_000_005A_01C27E88.79B98A90"
X-Priority: 3
Return-Path: user1@domain1.com
X-OriginalArrivalTime: 28 Oct 2002 13:45:00.0541 (UTC) FILETIME=[35F0A2D0:01C27E88]

This is a multi-part message in MIME format (If you see this in the message 
body, there is a problem. Notice there is no space or CRLF in the headers in the previous text. There must be no space until the message body itself)

This message is in MIME format. Since your mail reader does not understand this 
format, some or all of this message may not be legible. (If you see this in the 
message body, there is a problem)

------=_NextPart_000_005A_01C27E88.79B98A90
Content-Type: text/plain;
charset="iso-8859-1"
Content-Transfer-Encoding: 7bit

Can you see me now??!! (This is the text of the message. You see this in your mail client.)

------=_NextPart_000_005A_01C27E88.79B98A90
Content-Type: image/jpeg;
	name="Haloweenpictures.jpg"
Content-Transfer-Encoding: base64  
Content-Disposition: attachment;
	filename="Haloweenpictures.jpg"

/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB
/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB
/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB/9j/4AAQSkZJRgABAQEBLAEsAAD/2wB
------=_NextPart_000_005A_01C27E88.79B98A90--

') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:44'!
exampleParensInSubject
	"This message has an un-closed recursive multi-part message in it."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleParensInSubject)"

	^(ReadWriteStream with:
'From: "Sandwich, Bob" <sandwichb@bpi.edu>
Sender: "Sandwich, Bob" <sandwichb@bpi.edu>
To: "Aston, Rick"
Subject: RE: Perf Mgmt - try just clicking on this (there are a couple of gotchas in the URL that could hang up keyboardists
Date: Mon, 19 Sep 2005 13:21:52 -0500
Message-ID: <9ABB7953D4951A4E851BDC1B8D93506C0169FDF6@SI-ECL01.US.SINET.SI.EDU>
MIME-Version: 1.0
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_4649_01C8489F.96C51F00"
X-Mailer: Microsoft Office Outlook 11
Thread-Index: AcW9M3PlBhpFW7mzQUyfZqQpVdxp6gAE4i2w
x-mimeole: Produced By Microsoft MimeOLE V6.00.2900.3198
In-Reply-To: <7B7FDF0E44197442A53FA1E3436963FAC152FC@SI-ECL01.US.SINET.SI.EDU>

This is a multi-part message in MIME format.

------=_NextPart_000_4649_01C8489F.96C51F00
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

worked

-----Original Message-----
From: Aston, Rick 
Sent: Monday, September 19, 2005 12:02 PM
To: Sandwich, Bob
Subject: Perf Mgmt - try just clicking on this (there are a couple of
gotchas in the URL that could hang up keyboardists

http://ofeo.bpi.edu/PerformanceManagementPage.htm
l 

Rick Aston
Information Technology Archivist



------=_NextPart_000_4649_01C8489F.96C51F00
Content-Type: text/html;
	charset="us-ascii"
Content-Transfer-Encoding: quoted-printable

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
charset=3Dus-ascii">
<META NAME=3D"Generator" CONTENT=3D"MS Exchange Server version =
6.5.7036.0">
<TITLE>RE: Perf Mgmt - try just clicking on this (there are a couple of =
gotchas in the URL that could hang up keyboardists</TITLE>

</HTML>
------=_NextPart_000_4649_01C8489F.96C51F00--
') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 20:54'!
exampleSimpleMessage1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleSimpleMessage1)"

	^(ReadWriteStream with: 'Received:  from southrelay03.raleigh.ibm.com ([9.37.3.210]) by d04nhs05.raleigh.ibm.com (Lotus Domino Release 5.0.4a) with ESMTP id 2000091318113437:89073 ; Wed, 13 Sep 2000 18:11:34 -0400
Received:  from e3.ny.us.ibm.com (e3.esmtp.ibm.com [9.14.6.103]) by southrelay03.raleigh.ibm.com (8.8.8m3/NCO v4.93) with ESMTP id SAA38046 for <slb@us.ibm.com>; Wed, 13 Sep 2000 18:11:21 -0400
Received:  from rock.west.ora.com (rock.west.ora.com [204.148.43.8]) by e3.ny.us.ibm.com (8.9.3/8.9.3) with ESMTP id SAA183402 for <slb@us.ibm.com>; Wed, 13 Sep 2000 18:11:21 -0400@us.ibm.com>; Wed, 13 Sep 2000 18:11:07 -0400
Received:  from the.rocks.net (the.rocks.net [207.244.117.1]) by rock.west.ora.com (8.11.0/8.11.0) with SMTP id e8DM71o22784 for <p2psummit@oreilly.com>; Wed, 13 Sep 2000 15:07:02 -0700 (PDT)
Received:  by the.rocks.net(Lotus SMTP MTA SMTP v4.6 (462.2 9-3-1997)) id 85256959.007683A9 ; Wed, 13 Sep 2000 17:34:29 -0400
X_Lotus_FromDomain:  ROCKS.NET
From:  "Raymond Who" <ray@rocks.net>
SendTo:  p2psummit@oreilly.com
$MessageID:  <85256959.00730CF2.00@the.rocks.net>
PostedDate:  09/13/2000 06:09:08 PM
Subject:  Re: p2p concept map
MIME_Version:  1.0
$MIMETrack:  Itemize by SMTP Server on D04NHS05/04/H/IBM(Release 5.0.4a |July 24, 2000) at 09/13/2000 06:11:39 PM,MIME-CD by Router on D04NHS05/04/H/IBM(Release 5.0.4a |July 24, 2000) at 09/13/2000 06:11:39 PM,MIME-CD complete at 09/13/2000 06:11:39 PM
SMTPOriginator:  ray@rocks.net
RouteServers:  CN=D04NHS05/OU=04/OU=H/O=IBM,CN=D04NMS03/OU=04/OU=M/O=IBM
RouteTimes:  09/13/2000 06:11:39 PM-09/13/2000 06:11:39 PM,09/13/2000 06:11:40 PM-09/13/2000 06:11:41 PM
$Orig:  D31EAA3654B006ED852569590079EABB
Categories:  
$Revisions:  ,09/13/2000 06:11:40 PM
$MsgTrackFlags:  0
DeliveredDate:  09/13/2000 06:11:41 PM
DocExExpireDate:  09/13/2099 12:00:00 AM
$UpdatedBy:  ,CN=D04NHS05/OU=04/OU=H/O=IBM,CN=Someone/OU=Raleigh/O=IBM

Related to Jon''s notion of a concept map, I''d been toying with various
aspects of peer infrastructure if only to organize my thoughts.  Although
surely not complete, the following might catalyze some discussion:

basic definition of "peer"
     peers are people?
     peers are processes/programs?
     peers are devices?
user, device, resource, and service naming and addressing
     e.g. pseudonym, urn, x.509 dn, dns host, email addr, ip addr:port, ??
user & device authentication
     e.g. none, x.509, spki/sdsi, pgp, ??
user & device presence/state awareness
     e.g. dns, dyndns, ?? for devices
     e.g. jabber, aol, pepp, ??
user, device, service discovery
     distributed (lan multicast, horizon-limited recursion, directed query)
?
     centralized (directory) ?
     manual (buddy list, bookmarks) ?
communications
     transport protocols (http, smtp, bxxp, ??)
     data formats / schemas
     compression methods (wbxml?)
     encryption methods
     unicast?  multicast?  streaming?
     direct peer?  indirect proxy?
     adaptive transports & transparency methodologies
          dealing with firewalls, nats, and other obstacles
          dealing with variable bandwidth/latency/jitter
application transaction model
     rpc (eg. soap)?  mq (e.g. smtp)?
middleware services
     event notification
     resource aggregation (computation, storage)
     resource synchronization, replication, caching
     cooperative state management (workflow, games)
     policy management (security, capabilities)

Also, in case you haven''t run across it, I''d suggest reading Dave
Messerschmitt''s ''96 paper on the convergence of telecommunications and
computing.  I''ve long felt that the paper gives a great overview of
distributed computing in general, and of client/server vs. peer in
particular.

http://divine.eecs.berkeley.edu/~messer/PAPERS/96/Proc1/
or
http://divine.eecs.berkeley.edu/~messer/PAPERS/96/Proc1/Proc1.pdf

Ray') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 21:00'!
exampleSingleBodyHtmlMessage1
	"answer the message stream"
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleSingleBodyHtmlMessage1)"

	^(ReadWriteStream with: 'From - Tue May 22 19:52:54 2007
X-Mozilla-Status: 0001
X-Mozilla-Status2: 00800000
Message-ID: <46539063.6020809@mindspring.com>
Date: Tue, 22 May 2007 19:52:51 -0500
From: Steve <slb@mindspring.com>
User-Agent: Thunderbird 2.0.0.0 (Windows/20070326)
MIME-Version: 1.0
To:  joeblow@anywhere.com
Subject: test single body html
Content-Type: text/html; charset=ISO-8859-1
Content-Transfer-Encoding: 7bit

<!!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
</head>
<body bgcolor="#ffffff" text="#000000">
So,<b> this is sup</b>posed<i> to be just ht</i>ml.&nbsp; <u>Is it?</u><br>
<pre class="moz-signature" cols="72">-- 

___  Multicellular Computing <a class="moz-txt-link-abbreviated"
 href="http://www.evolutionofcomputing.org">www.evolutionofcomputing.org</a> ___

In the 20th century we created ever more capable computers.
Now we create ever more elegant groups of collaborating computers.
We recapitulate the biological evolution from single-cell to multi-cell organisms.</pre>

</body>
</html>

') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 15:57'!
exampleWithAppledouble1
	"This message has a multipart/appledouble and some empty attachment parts.
	 Note: the large attachment has been severely shortened, And the ending boundary
	 of that attachment doesn't begin with '--' which is illegal but common."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleWithAppledouble1)"

	^(ReadWriteStream with:
'Return-Path: <cathy.blough@pharma.pbs.com>
Received: from gatekeeper2.pbs.com (gatekeeper2.pbs.com [194.191.169.74])
	by mail.uncw.edu (8.11.6/8.11.6) with SMTP id f7UEVC812079
	for <blough@mail.uncw.edu>; Thu, 30 Aug 2001 10:31:13 -0400 (EDT)
Received: from NVCHBS-S0121.is.chbs (nvchbs-s0121.is.chbs [192.37.33.41])
	by mtap1.is.chbs (8.11.3/8.11.3) with ESMTP id f7UEV1p227972
	for <blough@mail.uncw.edu>; Thu, 30 Aug 2001 16:31:01 +0200
Subject: danger to Whoville!!
To: blough@mail.uncw.edu
From: cathy.blough@pharma.pbs.com
Date: Thu, 30 Aug 2001 10:30:39 -0400
Message-ID: <OF7030CCC3.06DC7525-ON85256AB8.004FAE1E@is.chbs>
X-MIMETrack: Serialize by Router on CHBSMN12/N1/Nova(Release 5.0.8 |June 18, 2001) at
 08/30/2001 04:31:01 PM
Content-Disposition: inline
X-UIDL: d"Q"!!Fja!!!!oQ#"!!o3V!!!!
MIME-Version: 1.0
Content-type: multipart/mixed; 
	Boundary="0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E"

This is a multi-part message in MIME format.

--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-Type: text/plain; charset="iso-8859-1"

---------------------- Forwarded by Cathy Blough/PH/Nova on
08/30/2001 10:30 AM ---------------------------

Cathy Blough
08/27/2001 09:56 AM

To:   Cathy Blough/PH/Nova@PH
cc:
Subject:
                                                                 
 (Embedded                                                       
 image moved   (Embedded image moved to file: pic11008.pcx)      
 to file:                                                        
 pic06224.pcx)                                                   
                                                                 

(See attached file: res.doc)(See attached file: Mondaypm.ppt)


--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-type: application/octet-stream; 
	name="pic06224.pcx"
Content-Disposition: attachment; filename="pic06224.pcx"

--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-Type: text/plain;


"pic06224.pcx" (missing attachment)
--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-type: application/octet-stream; 
	name="pic11008.pcx"
Content-Disposition: attachment; filename="pic11008.pcx"

--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-Type: text/plain;


"pic11008.pcx" (missing attachment)

--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-Disposition: attachment
Content-Type: multipart/appledouble;
	boundary=0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E_E2mXatt


--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E_E2mXatt
Content-Disposition: attachment;
	filename="res.doc"
Content-Transfer-Encoding: base64
Content-Type: application/applefile;
	name="res.doc"

AWBwACAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAJAAAAPgAAAAoAAAADAAAASAAAAAcAAAACAAAA
TwAAAR5XRVNXRAEAcmVzLmRvYwAAAQAAAAEAAAAAAAAAAB4AAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAEAAAAB
AAAAAAAAAAAeU09AUeAIAAHAAe//8=


--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E_E2mXatt
Content-Disposition: attachment;
	filename="res.doc"
Content-Type: application/octet-stream;
	name="res.doc"
Content-Transfer-Encoding: base64

4KGxGuEAAAAAAAAAAAAAAAAAAAAAPgADAP7/CQAGAAAAAAAAAAAAAAABAAAAOAAAAAAAAAAA
EAAAOgAAAAEAAAD+////AAAAADcAAAD/////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAD+/ABAACAAAAAAAAAAAAAAAAAAAAAAABAAAA4IWf8vlPaBCrkQgA
Kyez2TAAAACcAQAAAAAEAAACQAAAAAgAAAJgAAAADAAAAqAAAAAQAAAC4AAAABQAAANAAAAAG
bWm9tZSwgeWVya2VzLCBhdGxhbnRhAB4AAAABAAAAAGVzAAALAAAATm9ybWFsLmRv
dABvHgAAAA4AAABTZWN0b3IgUGhhcm1hACwgHgAAAAIAAAAN0HgAAABMAAABNaWNyb3NvZnQg
V29yZCA4LjAAa0AAAAAAfAneBQAAAEAAAAAANF1zEc3AAUAAAAAA9tZK2NTAAQMAAAABAAAAAwAA
AKYDAAADAAAAzBQAAAMAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=

0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E_E2mXatt--

--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E
Content-Type: text/plain;


"onedayam.ppt" (missing attachment)
--0__=85256AB8004FAE1E8f9e8a93df938690918c85256AB8004FAE1E--') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:00'!
exampleWithAppledouble2
	"This message has a multipart/appledouble and some empty attachment parts.
	 Note: the large attachment has been severely shortened, And the ending boundary
	 of that attachment doesn't begin with '--' which is illegal but common."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleWithAppledouble2)"

	^(ReadWriteStream with:
'From ???@??? Mon Sep 17 16:44:43 2001
Return-Path: <goldscj@mail.uncw.edu>
Received: from [129.85.16.114] (bonne2.uncw.edu [129.85.16.114])
	by mail.uncw.edu (8.11.6/8.11.6) with ESMTP id f8HJsps27962;
	Mon, 17 Sep 2001 15:54:52 -0400 (EDT)
Message-Id: <a05010409b7cc13072795@[129.85.16.114]>
Date: Mon, 17 Sep 2001 15:54:18 -0500
To: betsyb
From: Jennifer Brown <brnscj@mail.uncw.edu>
Subject: Letter to John 
Cc: onnerj, vonep
X-UIDL: T1$#!!+&\!!!!F3m"!!V4O"!!
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary="============_-1211362437==_============"

This is a multi-part message in MIME format.

--============_-1211362437==_============
Content-Type: text/plain; charset="iso-8859-1"

Hi Bets,
Please review for any changes you would like to make. Also, I used 
Diane''s name as the contact person for the meeting but I am not sure 
if she is handling your schedule.
Jan
x873

--============_-1211362437==_============
Content-Disposition: attachment
Content-Type: multipart/appledouble;
	boundary=============_-1211362437==_============_E2mXatt


--============_-1211362437==_============_E2mXatt
Content-Disposition: attachment;
	filename="juhn.doc"
Content-Transfer-Encoding: base64
Content-Type: application/applefile;
	name="juhn.doc"

AAUWBwACAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAJAAAAPgAAAAoAAAADAAAASAAAAAsAAAACAAAA
UwAAAR5XREJOTVNXRAEAR2VybGFjaC5kb2MAAAEAAAABAAAAAAAAAAAeAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAB
AAAAAQAAAAAAAAAAHlNPUlQE/gCAABwAHv//


--============_-1211362437==_============_E2mXatt
Content-Disposition: attachment;
	filename="juhn.doc"
Content-Type: application/octet-stream;
	name="juhn.doc"
Content-Transfer-Encoding: base64

0M8R4KGxGuEAAAAAAAAAAAAAAAAAAAAAPDAP7/CQAGAAAAAAAAAAAAAAABAAAAJQAAAAAAAAAA
EAAAJwAAAAEAAAD+////AAAAACQAAAD/////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
dWRlcyBraWYW5kIGFwcHJvdmUgYWxsIGFkdmVydGlzaW5nIGFuZCBwcm9t
cgAgAEcAbwBsAGQAcwBjAGgAbABhAGcAJQBKAGUAbgBuAGkAZgBlAHIAJwBzACAATQBhAGMAOgBE
AGUAcwBrAHQAbwBwAgBlAHIAJwBzACAATQBhAGMAOgBEAGUAcwBrAHQAbwBwACAARgBv
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABYAAAAAAAAAAAAAAAAAAAAAAAA
////////////////////////////////////////////////////////////////////////////
/////////////////////wEA/v8CAAEA/////wYJAgAAAAAAwAAAAAAAAEYYAAAATWljcm9zb2Z0
IFdvcmQgRG9jdW1lbnQA/v///05CNlcQAAAAV29yZC5Eb2N1bWVudC44AAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAA

============_-1211362437==_============_E2mXatt--

--============_-1211362437==_============--') reset! !

!EmailParserExamples class methodsFor: 'example legal messages' stamp: 'SLB 8/13/2008 16:13'!
exampleWithChild1
	"This message has a multipart/alternative text/html, a child message, and an empty body part."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleWithChild1)"

	^(ReadWriteStream with:
'From - Tue Feb 13 11:04:36 2007
X-Account-Key: account2
X-UIDL: 1hgZ391AC3Nl3qB4
X-Mozilla-Status: 0003
X-Mozilla-Status2: 10000000
Status:  U
Return-Path: <unknown@random.edu>
Received: from ut-mailout02.ut.edu ([160.111.103.154])
	by montgomery.mail.atl.earthlink.net (EarthLink SMTP Server) with ESMTP id 1hgZ391AC3Nl3qB2
	for <sburbeck@mindspring.com>; Tue, 13 Feb 2007 09:54:31 -0500 (EST)
Received: from Gate-MTA by utmail1.ut.edu
	with Novell_GroupWise; Tue, 13 Feb 2007 09:54:30 -0500
Message-Id: <s5d18ad6.032@utmail1.ut.edu>
X-Mailer: Novell GroupWise Internet Agent 6.5.2 
Date: Tue, 13 Feb 2007 09:58:00 -0500
From: "Maxine Unknown" <unknown@random.edu>
To: <bsimpson@earthlink.net>
Subject: Fwd: [Dspace-general] open repositories 2007
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary="=__PartC5E15CE8.0__="
X-ELNK-Info: spv=0;
X-ELNK-AV: 0
X-ELNK-Info: sbv=0; sbrc=.0; sbf=00; sbw=000;

This is a MIME message. If you are reading this text, you may want to 
consider changing to a mail reader or gateway that understands how to 
properly handle MIME multipart messages.

--=__PartC5E15CE8.0__=
Content-Type: multipart/alternative; boundary="=__PartC5E15CE8.1__="

--=__PartC5E15CE8.1__=
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit

Bart,
FYI
 
Homer

--=__PartC5E15CE8.1__=
Content-Type: text/html; charset=ISO-8859-1
Content-Transfer-Encoding: quoted-printable
Content-Description: HTML

<HTML><HEAD>
<META http-equiv=3DContent-Type content=3D"text/html; charset=3Diso-8859-1"=
>
<META content=3D"MSHTML 6.00.2900.3020" name=3DGENERATOR></HEAD>
<BODY style=3D"MARGIN: 4px 4px 1px; FONT: 10pt Tahoma">
<DIV>Steve,</DIV>
<DIV>FYI</DIV>
<DIV>&nbsp;</DIV>
<DIV>Lynda</DIV></BODY></HTML>

--=__PartC5E15CE8.1__=--
--=__PartC5E15CE8.0__=
Content-Type: message/rfc822

Return-path: <dspace-general-bounces@mit.edu>
Received: from av-blat03.ut.edu [160.111.252.24]
	by utmail1.ut.edu; Mon, 12 Feb 2007 17:15:02 -0500
Received: from av-ems01.ut.edu ([127.0.0.1])
 by localhost (av-ems01 [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 13482-05 for <bsimpson@whoville.edu>;
 Mon, 12 Feb 2007 17:14:59 -0500 (EST)
Received: from pch.mit.edu (PCH.MIT.EDU [18.7.21.90])
	by ut-ems01.ut.edu (UT-Mailer) with ESMTP id 06BAF19D2
	for <bsimpson@whoville.edu>; Mon, 12 Feb 2007 17:14:59 -0500 (EST)
Received: from fort-point-station.mit.edu (FORT-POINT-STATION.MIT.EDU
	[18.7.7.76])
	by pch.mit.edu (8.13.6/8.12.8) with ESMTP id l1CM8S2r017106
	for <dspace-general@PCH.mit.edu>; Mon, 12 Feb 2007 17:08:28 -0500
Received: from mta-2.cc.nd.edu (mta-2.cc.nd.edu [129.74.250.37])
	(using TLSv1 with cipher DHE-RSA-AES256-SHA (256/256 bits))
	(No client certificate requested)
	by mit.edu (Spam Firewall) with ESMTP id A52522660F8
	for <dspace-general@mit.edu>; Mon, 12 Feb 2007 17:08:21 -0500 (EST)
Received: from [192.168.1.6] (adsl-70-142-236-105.dsl.sbndin.sbcglobal.net
	[70.142.236.105]) (authenticated bits=0)
	by mta-2.cc.nd.edu (Switch-3.2.2/Switch-3.2.2) with ESMTP id
	l1CM867l018044
	(version=TLSv1/SSLv3 cipher=AES128-SHA bits=128 verify=NO)
	for <dspace-general@mit.edu>; Mon, 12 Feb 2007 17:08:16 -0500 (EST)
Mime-Version: 1.0 (Apple Message framework v752.2)
Message-Id: <EF310F13-2EE2-4110-8A5C-C3B0336A1F61@nd.edu>
To: dspace-general@mit.edu
From: Benjamin Morgan <bmorgan@ind.edu>
Date: Mon, 12 Feb 2007 17:08:14 -0500
X-Mailer: Apple Mail (2.752.2)
X-ND-MTA-Date: Mon, 12 Feb 2007 17:08:19 EST
X-Scanned-By: MIMEDefang 2.42
X-Scanned-By: MIMEDefang 2.57 on 129.74.250.37
X-Spam-Score: 0.13
Subject: [Dspace-general] open repositories 2007
X-BeenThere: dspace-general@mit.edu
X-Mailman-Version: 2.1.6
Precedence: list
List-Id: "DSpace general topics \(non-technical\)" <dspace-general.mit.edu>
List-Unsubscribe: <http://mailman.mit.edu/mailman/listinfo/dspace-general>,
	<mailto:dspace-general-request@mit.edu?subject=unsubscribe>
List-Archive: <http://mailman.mit.edu/pipermail/dspace-general>
List-Post: <mailto:dspace-general@mit.edu>
List-Help: <mailto:dspace-general-request@mit.edu?subject=help>
List-Subscribe: <http://mailman.mit.edu/mailman/listinfo/dspace-general>,
	<mailto:dspace-general-request@mit.edu?subject=subscribe>
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: 7bit
Sender: dspace-general-bounces@mit.edu
Errors-To: dspace-general-bounces@mit.edu
X-Virus-Scanned: UT-EMS border system (UT+SA)


I have written up an Open Repositories 2007 travel log. From the  
abstract:

   This text documents my experiences at the Open Repositories 2007
   conference, January 22-26, San Antonio (Texas). In a sentence I
   learned two things: 1) institutional repository software such as
   Fedora, DSpace, and EPrints are increasingly being used for more
   than open access publishing efforts, and 2) the Web Services API
   of Fedora makes it relatively easy for developers using any
   programming language to interface with the underlying core.

   http://infomotions.com/musings/open-repositories-2007/

Corrections, clarifications, etc. are welcome.

-- 
Ben Morgan
University Libraries of Univ. Texas


_______________________________________________
Dspace-general mailing list
Dspace-general@mit.edu
http://mailman.mit.edu/mailman/listinfo/dspace-general

--=__PartC5E15CE8.0__=--') reset! !


!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:33'!
exampleBadAolMacMessage1
	"This message has an un-closed recursive multi-part message in it."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadAolMacMessage1)"

	^(ReadWriteStream with:
'Return-Path: <scoop@aol.com>
Received: from localhost by walt1 with LMTP for <arboc@imap.fzzz.edu>; Sat, 27 Mar 2004 09:15:49 -0500
Received: from smtp1.fzzz.edu (smtp1.fzzz.edu [19.125.248.101])
	by imap.fzzz.edu (Switch-3.1.4/Switch-3.1.0) with ESMTP id i2REFnpn025304
	(version=TLSv1/SSLv3 cipher=EDH-RSA-DES-CBC3-SHA bits=168 verify=OK)
	for <arboc@imap.fzzz.edu>; Sat, 27 Mar 2004 09:15:49 -0500 (EST)
Received: from scoop@aol.com
	by imo-d23.mx.aol.com (mail_out_v37_r1.2.) id p.ea.4a6e41a0 (4246);
	Sat, 27 Mar 2004 09:15:37 -0500 (EST)
From: scoop@aol.com
Message-ID: <ea.4e5a31a0.2d96a689@aol.com>
Date: Sat, 27 Mar 2004 09:15:37 EST
Subject: FROM a republican pal, praising a Republican columnist
To: tebrainx@mpix.net, arboc@mail.fzzz.edu, tebrain@yahoo.com,
        bobe@epix.net, michaelbrain@cox.net, scrip@aol.com
X-Mailer: AOL 5.0 for Mac sub 46
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="part1_ea.4a6e41a0.2d96e689_boundary"

This is a multi-part message in MIME format.

--part1_ea.4a6e41a0.2d96e689_boundary
Content-Type: text/plain; charset="iso-8859-1"

Return-Path: <cm@minormusic.com>
Received: from  rlg-gg04.mx.aol.com (rlg-gg04.mail.aol.com [172.18.180.100]) by air-yg03.mail.aol.com 

(v98.19) with ESMTP id MAILINYG31-28a40658b4ad5; Sat, 27 Mar 2004 09:10:50 -0500
Received: from  mail.bethesdahosting.com (mail.bethesdahosting.com [209.183.221.9]) by rlg-gg04.mx.aol.com 

(v98.5) with ESMTP id MAILRELAYINYG410-28a40658b4ad5; Sat, 27 Mar 2004 09:10:18 -0500
Received: from thinkpad ([204.111.96.53])
	(authenticated user Majormusic@majormusic.com)
	by mtgcp.com (mail.bethesdahosting.com [127.0.0.1])
	(MDaemon.PRO.v7.0.1.R)
	with ESMTP id md50000064039.msg
	for <scoop@aol.com>; Sat, 27 Mar 2004 09:03:20 -0500
From: "Chris Major" <cm@majormusic.com>
To: "Michael Ding" <mdowding@netscape.com>, <kjh@bu.edu>,
        "Jim Brain \(Jim Brain\)" <scoop@aol.com>
Subject: Charley Reese: Clinton better
Date: Sat, 27 Mar 2004 09:07:48 -0500
Message-ID: <00ab01c42404$e16dfc20$6571a8c0@thinkpad>
MIME-Version: 1.0
--part1_ea.4a6e41a0.2d96e689_boundary
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_00AD_01C413DA.F997F420"
X-Priority: 3 (Normal)
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2800.1106
In-Reply-To: <001701c4147c$38910bf0$872c5bd1@D5MGM721>
X-Spam-Processed: mail.bethesdahosting.com, Sat, 27 Mar 2004 09:03:20 -0500
	(not processed: message from valid local sender)
X-Return-Path: cm@majormusic.com
X-MDaemon-Deliver-To: scoop@aol.com
X-AOL-IP: 209.183.221.9

--part1_ea.4a6e41a0.2d96e689_boundary
Content-Type: text/html;

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HEAD><TITLE>Message</TITLE>
<META http-equiv=Content-Type content="text/html; charset=ISO-8859-1">
<META content="MSHTML 6.00.2800.1106" name=GENERATOR></HEAD>
<BODY>
<DIV><SPAN class=610350414-27032004>
<FONT face=Arial size=2>
Reese, a journalist for 49 years, opines,    
</FONT>
</SPAN></DIV></SECTION:CONTENT_FOOTER></BODY></HTML>

--part1_ea.4a6e41a0.2d96e689_boundary--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:35'!
exampleBadMessage1
	"This message has an un-closed recursive multi-part message in it."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadMessage1)"

	^(ReadWriteStream with:
'Return-Path: <brookg@mail.uncw.edu>
Received: from deptvax.uncw.edu (mcewenb21-pc.uncw.edu [129.85.19.196])
	by mail.uncw.edu (8.11.6/8.11.6) with ESMTP id f94Lwms11106
	for <boohooc@mail.uncw.edu>; Thu, 4 Oct 2001 17:58:48 -0400 (EDT)
Message-ID: <3BBCD9BB.CC79EE24@deptvax.uncw.edu>
Date: Thu, 04 Oct 2001 17:50:51 -0400
From: Wendy Brooks <brookg@mail.uncw.edu>
To: boohooc@mail.uncw.edu
Subject: [Fwd: The Foster Pet Project-update]
MIME-Version: 1.0
Content-Type: multipart/mixed;
 boundary="------------AD0CD65DD63A8780AAD5C0E3"

This is a multi-part message in MIME format.

--------------AD0CD65DD63A8780AAD5C0E3
Content-Type: text/plain; charset="iso-8859-1"

Return-Path: <brookg@mail.uncw.edu>
Received: from deptvax.uncw.edu (mcewenb21-pc.uncw.edu [129.85.19.196])
	by mail.uncw.edu (8.11.6/8.11.6) with ESMTP id f8UNgrs13544;
	Sun, 30 Sep 2001 19:42:53 -0400 (EDT)
Message-ID: <3BB7AC21.6915CF27@deptvax.uncw.edu>
Date: Sun, 30 Sep 2001 19:34:57 -0400
From: Wendy Brooks <brookg@mail.uncw.edu>
X-Mailer: Mozilla 4.72 [en] (Win98; I)
MIME-Version: 1.0
To: undisclosed-recipients@mail.uncw.edu
Subject: The Foster Pet Project-update
--------------AD0CD65DD63A8780AAD5C0E3
Content-Type: multipart/mixed;
 boundary="------------0F05601881F517A4537B9F73"
X-Mozilla-Status2: 00000000

Note that, since there is no opening boundary string, everything from 
here on is parsed as preamble, including the outer boundary strings.

--------------AD0CD65DD63A8780AAD5C0E3
Content-Type: text/plain;


"BSPC form.doc 1" (missing attachment)
--------------AD0CD65DD63A8780AAD5C0E3--') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:43'!
exampleBadMessage10Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because
	 of problems with boundary strings."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage10Skeleton)"

	^ (ReadWriteStream with:
'Return-Path: <Dadbearts@aol.com>
Received: from imo-m10.mx.aol.com (imo-m10.mx.aol.com [64.12.136.165])
	by mail.ucla.edu (8.12.5/8.12.5) with ESMTP id g7SIcO7J018184
	for <boohooc@ucla.edu>; Wed, 28 Aug 2002 14:38:24 -0400 (EDT)
Received: from Dadbearts@aol.com
	by imo-m10.mx.aol.com (mail_out_v34.10.) id 2.181.d847543 (16109)
	 for <boohooc@ucla.edu>; Wed, 28 Aug 2002 14:38:21 -0400 (EDT)
Received: from  aol.com (mow-m27.webmail.aol.com [64.12.137.4]) by air-id12.mx.aol.com (v88.20) with ESMTP id MAILINID121-0828143820; Wed, 28 Aug 2002 14:38:20 -0400
Date: Wed, 28 Aug 2002 14:38:20 -0400
From: Dadbearts@aol.com
To: boohooc@ucla.edu
Subject: press release
Message-ID: <278D82A4.0F9761BE.026F1C4A@aol.com>
X-Mailer: Atlas Mailer 2.0
Content-Transfer-Encoding: 8bit
X-UIDL: "6i!!!!(?4"!!pXE!!!!@X~!!!!
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary=-------27914204f9b211e27914204f9b211e

This is a multi-part message in MIME format.

---------27914204f9b211e27914204f9b211e
Content-Type: text/plain; charset="iso-8859-1"

Return-Path: <K.Muslich@nurure.com>
Received: from  rly-xd03.mx.aol.com (rly-xd03.mail.aol.com [172.20.105.168]) by air-xd02.mail.aol.com (v88.20) with ESMTP id MAILINXD23-0828120422; Wed, 28 Aug 2002 12:04:22 2000
Received: from  mail.ucla.edu (ucla.edu [129.85.1.21]) by rly-xd03.mx.aol.com (v88.20) with ESMTP id MAILRELAYINXD36-0828120355; Wed, 28 Aug 2002 12:03:55 -0400
Received: from UK1APPS2.nurure.com by smtp-ldn.macmillan.co.uk (8.10.2/8.10.2) id g7SFoGl23474; Wed, 28 Aug 2002 16:50:16 +0100
Received: by UK1APPS2.nurure.com with Internet Mail Service (5.5.2653.19)
	id <QW4S2V2M>; Wed, 28 Aug 2002 17:04:30 +0100
Message-ID: <125F7834E11A4741A7C79412EE35A4F9FC8DA5@UK2ADPS2.nurure.com>
From: "Muslich, Katharine" <K.Muslich@nurture.com>
To: "''Peter Dadbearts''" <peter@ucla.edu>
Subject: RE: Panda et al. Nature Sep 5
Date: Wed, 28 Aug 2002 17:03:29 +0100
MIME-Version: 1.0
X-Mailer: Internet Mail Service (5.5.2653.19)
---------27914204f9b211e27914204f9b211e
Content-Type: multipart/mixed;
	boundary="----_=_NextPart_000_01C24EAC.7341F8C0"

Dear Peter,

here is a subbed version of our press release for your paper.

Kind regards,

Katharine Muslich
Press Assistant

Tel:   +44 020 7843 4658
Fax:   +44 020 7843 4951
Email: k.muslich@nurture.com



-----Original Message-----
From: Peter Dadbearts [mailto:peter@ucla.edu]
Sent: 27 August 2002 19:26
To: Muslich, Katharine
Subject: RE: Panda et al. Nurture Sep 5


Katharine,

Thanks. I fully respect your journalistic independence and won''t 
argue with the style of Nurture''s press releases. In my experience, 
however, factual errors are expected. My main concern is to avoid 
these at the stage of the press release, so that they are not 
perpetrated by journalists who quote the press release verbatim.

Sincerely,

Peter Dadbearts



>Dear Dr. Dadbearts,
>
>
>As soon as I have a subbed copy of the press release, I will send it to you
>so that you can review it.  Please contact me if you have any queries.
>
>-----Original Message-----
>From: Peter Dadbearts [mailto:peter@ucla.edu]
>Sent: 27 August 2002 18:57
>To: Muslich, Katharine
>Cc: k.mcgoldrick@nurturedc.com
>Subject: Del Punta et al. Nurture Sep 5
>
>
>Katharine,
>
>I called Katie McGoldrick in the Washington bureau to enquire if our
>
>Regards,
>
>Peter Dadbearts
>
>

 DISCLAIMER: This e-mail is confidential and should not be used by anyone
who is not the original intended recipient.


---------27914204f9b211e27914204f9b211e
Content-Disposition: attachment
Content-Type: multipart/appledouble;
	boundary=-------27914204f9b211e27914204f9b211e_E2mXatt


---------27914204f9b211e27914204f9b211e_E2mXatt
Content-Disposition: attachment;
	filename="mombaerts.doc"
Content-Transfer-Encoding: base64
Content-Type: application/applefile;
	name="mombaerts.doc"

AAUWBwACAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAJAAAAPgAAAAoAAAADAAAASAAAAA0AAAACAAAA
VQAAAR5XREJOTVNXRAAAbW9tYmFlcnRzLmRvYwAAAQAAAAEAAAAAAAAAAB4AAAAAAAAAAAAAAAAA
AAEAAAABAAAAAAAAAAAeAsQPKAXxAAAAHAAe//8=


---------27914204f9b211e27914204f9b211e_E2mXatt
Content-Disposition: attachment;
	filename="mombaerts.doc"
Content-Type: application/octet-stream;
	name="mombaerts.doc"
Content-Transfer-Encoding: base64

0M8R4KGxGuEAAAAAAAAAAAAAAAAAAAAAPgADAP7/CQAGAAAAAAAAAAAAAAABAAAAKAAAAAAAAAAA
EAAAKgAAAAEAAAD+////AAAAACcAAAD/////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA

-------27914204f9b211e27914204f9b211e_E2mXatt--

---------27914204f9b211e27914204f9b211e--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 12:08'!
exampleBadMessage11
	"This message has an un-closed recursive multi-part message in it."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadMessage11)"

	^(ReadWriteStream with:
'X-MimeOLE: Produced By Microsoft Exchange V6.5
Content-class: urn:content-classes:message
MIME-Version: 1.0
Content-Type: text/html
Content-Transfer-Encoding: binary
Subject: RE: Memo regarding Day Camp Policies
Date: Wed, 22 Mar 2006 10:44:36 -0500
Message-ID: <83257AA46AC48C4EBC9FF027927393A91C8B45@SI-ECL01.US.SINET.SI.EDU>
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: <83257AA46AC48C4EBC9FF027927393A91C8B45@SI-ECL01.US.SINET.SI.EDU>
Thread-Topic: Memo regarding Day Camp Policies
Thread-Index: AcZNwgwMiTAa4mnjQt+yKEG2QT7FFAABViLg
From: "Gallagher, Robert" <gallagherr@si.edu>
To: "Erb, Amy" <erba@si.edu>
Status: RO
X-Folder: Imported Mail

<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" xmlns:st1="urn:schemas-microsoft-com:office:smarttags" xmlns="http://www.w3.org/TR/REC-html40">

<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=us-ascii">


<meta name=Generator content="Microsoft Word 11 (filtered medium)">
<!!--[if !!mso]>
<style>
v\:* {behavior:url(#default#VML);}
o\:* {behavior:url(#default#VML);}
w\:* {behavior:url(#default#VML);}
.shape {behavior:url(#default#VML);}
</style>
<!![endif]--><o:SmartTagType
 namespaceuri="urn:schemas-microsoft-com:office:smarttags" name="PostalCode"
 downloadurl="http://www.5iamas-microsoft-com:office:smarttags"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="State" downloadurl="http://www.5iamas-microsoft-com:office:smarttags"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="City" downloadurl="http://www.5iamas-microsoft-com:office:smarttags"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="Street" downloadurl="http://www.5iantlavalampft-com:office:smarttags"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="address" downloadurl="http://www.5iamas-microsoft-com:office:smarttags"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="PlaceType"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="PlaceName" downloadurl="http://www.5iantlavalamp.com/"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="place" downloadurl="http://www.5iantlavalamp.com/"/>
<o:SmartTagType namespaceuri="urn:schemas-microsoft-com:office:smarttags"
 name="PersonName"/>
<!!--[if !!mso]>
<style>
st1\:*{behavior:url(#default#ieooui) }
</style>
<!![endif]-->
<style>
<!!--
 /* Font Definitions */
 @font-face
	{font-family:Tahoma;
	panose-1:2 11 6 4 3 5 4 4 2 4;}
 /* Style Definitions */
 p.MsoNormal, li.MsoNormal, div.MsoNormal
	{margin:0in;
	margin-bottom:.0001pt;
	font-size:12.0pt;
	font-family:"Times New Roman";}
a:link, span.MsoHyperlink
	{color:blue;
	text-decoration:underline;}
a:visited, span.MsoHyperlinkFollowed
	{color:purple;
	text-decoration:underline;}
span.emailstyle17
	{font-family:Arial;
	color:windowtext;}
span.EmailStyle18
	{mso-style-type:personal-reply;
	font-family:"Times New Roman";
	color:blue;
	font-weight:normal;
	font-style:normal;
	text-decoration:none none;}
@page Section1
	{size:8.5in 11.0in;
	margin:1.0in 1.25in 1.0in 1.25in;}
div.Section1
	{page:Section1;}
-->
</style>

</head>

<body lang=EN-US link=blue vlink=purple>

<div class=Section1>

<p class=MsoNormal><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>Thanks Amy.&nbsp; I will fwd to the OGC,
but I wanted Tuck to look at this first to be sure he has no other questions or
concerns.<o:p></o:p></span></font></p>

<p class=MsoNormal><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''><o:p>&nbsp;</o:p></span></font></p>

<p class=MsoNormal><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>Bob<o:p></o:p></span></font></p>

<p class=MsoNormal><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''><o:p>&nbsp;</o:p></span></font></p>

<div>

<p class=MsoNormal><em><b><i><font size=4 color=blue face="Times New Roman"><span
style=''font-size:13.5pt;color:blue;font-weight:bold''>Robert P. Gallagher</span></font></i></b></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><em><i><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>Administrative Officer</span></font></i></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><em><i><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>Smithsonian Environmental <st1:place w:st="on"><st1:PlaceName
 w:st="on">Research</st1:PlaceName> <st1:PlaceType w:st="on">Center</st1:PlaceType></st1:place></span></font></i></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><st1:address w:st="on"><st1:Street w:st="on"><em><i><font
  size=3 color=blue face="Times New Roman"><span style=''font-size:12.0pt;
  color:blue''>PO Box</span></font></i></em></st1:Street><em><i><font
 color=blue face="Times New Roman"><span style=''color:blue''> 28</span></font></i></em></st1:address><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><st1:Street w:st="on"><st1:address w:st="on"><em><i><font
  size=3 color=blue face="Times New Roman"><span style=''font-size:12.0pt;
  color:blue''>647 Contees Wharf Road</span></font></i></em></st1:address></st1:Street><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><st1:place w:st="on"><st1:City w:st="on"><em><i><font
  size=3 color=blue face="Times New Roman"><span style=''font-size:12.0pt;
  color:blue''>Edgewater</span></font></i></em></st1:City><em><i><font
 color=blue face="Times New Roman"><span style=''color:blue''>, <st1:State w:st="on">MD</st1:State>&nbsp;
 <st1:PostalCode w:st="on">21037</st1:PostalCode></span></font></i></em></st1:place><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><em><i><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>443-482-2336 (V)</span></font></i></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><em><i><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>443-482-2295</span></font></i></em><em><i><font
size=4 color=blue face="Times New Roman"><span style=''font-size:13.5pt;
color:blue''> </span></font><font color=blue><span style=''color:blue''>(Fx)</span></font></i></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><em><i><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''>MRC 540</span></font></i></em><font
color=blue><span style=''color:blue''><o:p></o:p></span></font></p>

<p class=MsoNormal><font size=3 color=blue face="Times New Roman"><span
style=''font-size:12.0pt;color:blue''><a href="http://www.serc.si.edu">www.serc.si.edu</a></span></font><o:p></o:p></p>

</div>

<div style=''border:none;border-left:solid blue 1.5pt;padding:0in 0in 0in 4.0pt''>

<div>

<div class=MsoNormal align=center style=''text-align:center''><font size=3
face="Times New Roman"><span style=''font-size:12.0pt''>

<hr size=2 width="100%" align=center tabindex=-1>

</span></font></div>

<p class=MsoNormal><b><font size=2 face=Tahoma><span style=''font-size:10.0pt;
font-family:Tahoma;font-weight:bold''>From:</span></font></b><font size=2
face=Tahoma><span style=''font-size:10.0pt;font-family:Tahoma''> Erb, Amy <br>
<b><span style=''font-weight:bold''>Sent:</span></b> Wednesday, March 22, 2006
10:05 AM<br>
<b><span style=''font-weight:bold''>To:</span></b> Gallagher, Robert<br>
<b><span style=''font-weight:bold''>Cc:</span></b> <st1:PersonName w:st="on">Haddon,
 Mark</st1:PersonName>; Holly, Jane<br>
<b><span style=''font-weight:bold''>Subject:</span></b> Memo regarding Day Camp
Policies</span></font><o:p></o:p></p>

</div>

<p class=MsoNormal><font size=3 face="Times New Roman"><span style=''font-size:
12.0pt''><o:p>&nbsp;</o:p></span></font></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Hi Bob,</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>&nbsp;</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Attached to this email is a memo regarding an inquiry on
policies affecting the administration of summer day camps here at SERC.&nbsp;
Can you please pass this memo onto the Office of General Council and any other
appropriate staff regarding this inquiry?&nbsp; </span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>&nbsp;</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Thank you for your support.&nbsp; </span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>&nbsp;</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Amy Erb</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>STAR Coordinator</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Smithsonian Environmental <st1:place w:st="on"><st1:PlaceName
 w:st="on">Research</st1:PlaceName> <st1:PlaceType w:st="on">Center</st1:PlaceType></st1:place></span></font><o:p></o:p></p>

<p class=MsoNormal><st1:address w:st="on"><st1:Street w:st="on"><font size=2
  face=Arial><span style=''font-size:10.0pt;font-family:Arial''>PO Box</span></font></st1:Street><font
 size=2 face=Arial><span style=''font-size:10.0pt;font-family:Arial''> 28</span></font></st1:address><o:p></o:p></p>

<p class=MsoNormal><st1:Street w:st="on"><st1:address w:st="on"><font size=2
  face=Arial><span style=''font-size:10.0pt;font-family:Arial''>647 Contees Wharf
  Rd</span></font></st1:address></st1:Street><o:p></o:p></p>

<p class=MsoNormal><st1:place w:st="on"><st1:City w:st="on"><font size=2
  face=Arial><span style=''font-size:10.0pt;font-family:Arial''>Edgewater</span></font></st1:City><font
 size=2 face=Arial><span style=''font-size:10.0pt;font-family:Arial''>, <st1:State
 w:st="on">MD</st1:State> <st1:PostalCode w:st="on">21037-0028</st1:PostalCode></span></font></st1:place><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Phone: 443-482-2296</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''>Fax: 443-482-2319</span></font><o:p></o:p></p>

<p class=MsoNormal><font size=2 face=Arial><span style=''font-size:10.0pt;
font-family:Arial''><a href="mailto:erba@si.edu">erba@si.edu</a></span></font><o:p></o:p></p>

<p class=MsoNormal><font size=3 face="Times New Roman"><span style=''font-size:
12.0pt''>&nbsp;<o:p></o:p></span></font></p>

</div>

</div>

</body>

</html>
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:15'!
exampleBadMessage213Skeleton
	"answer the message stream.  This message fails to parse as of 6/25/07"
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage213Skeleton)"

	^(ReadWriteStream with:
'Message-Id: <p05100308b7e3985f2af8@[129.85.16.58]>
Date: Fri, 5 Oct 2001 13:04:52 -0400
To: bockc@mail.asu.edu (Cathy Bock)
From: baner@mail.asu.edu (Ralph Baner)
Subject: Fwd: E-Clips No. 3: October 5, 2001
Mime-Version: 1.0
Content-Type: multipart/Related; boundary="============_-1209820993==_mr============"
 ; type="text/html"

This is a multi-part message in MIME format.

--============_-1209820993==_mr============
--============_-1209820993==_mr============
Content-Type: text/html;

<!!doctype html public "-//W3C//DTD W3 HTML//EN">
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
Content-ID: &lt;image001.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image001.gif<br>
Content-Location: image001.gif<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
Content-ID: &lt;image002.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image002.gif<br>
Content-Location: image002.gif<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
<div>Content-ID: &lt;image003.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image003.gif<br>
Content-Location: image003.gif<br>
--============_-1209820993==_mr============
Content-Type: image/gif;<br>
Content-ID: &lt;image004.gif@01C14D9B.C720A6C0&gt;<br>
Content-Description: image004.gif<br>
Content-Location: image004.gif</div>
--============_-1209820993==_mr============--') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:18'!
exampleBadMessage2Skeleton
	"Answer the message stream.  This message failed to parse as of 1/15/08 because it
	 has parenses within the boundary string that the parser confuses with comments.
	 Fixed as of 1/16/08"
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage2Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <ajlevine@farble.net>
Received: from smtp.farble.net (smtp.farble.net [24.153.64.2])
	by mail.fluffle.edu (8.12.5/8.12.5) with ESMTP id g8SGUj00009989
	for <joebloc@mail.fluffle.edu>; Sat, 28 Sep 2002 12:30:46 -0400 (EDT)
Received: from s0023110473
 (pcp02723213pcs.ivylnd01.pa.farble.net [68.85.30.26])
 by mtaout05.ifarble.net
 (iPlanet Messaging Server 5.1 HotFix 1.4 (built Aug  5 2002))
 with SMTP id <0H3500CC9PUTSL@mtaout05.ifarble.net> for
 joebloc@mail.fluffle.edu; Sat, 28 Sep 2002 12:30:29 -0400 (EDT)
Date: Sat, 28 Sep 2002 12:35:40 -0400
From: Arnold Levine <ajlevine@farble.net>
Subject: interview
To: joebloc@mail.fluffle.edu
Message-id: <00ef01c2670d$1543dd00$1a1e5544@ivylnd01.pa.farble.net>
X-MIMEOLE: Produced By Microsoft MimeOLE V6.00.2600.0000
X-Mailer: Microsoft Outlook Express 6.00.2600.0000
X-Priority: 3
X-MSMail-priority: Normal
X-UIDL: i:B!!!!FP("!!gg2"!!JK>!!!!
MIME-version: 1.0
Content-type: multipart/alternative;
 boundary="Boundary_(ID_Z89BO7EQwDd9hm13hABaCQ)"

This is a multi-part message in MIME format.

--Boundary_(ID_Z89BO7EQwDd9hm13hABaCQ)
--Boundary_(ID_Z89BO7EQwDd9hm13hABaCQ)
Content-Type: text/html;

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HEAD>
<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">
<META content="MSHTML 6.00.2719.2200" name=GENERATOR>
<STYLE></STYLE>
</HEAD>
<BODY bgColor=#ffffff>
<DIV><FONT face=Arial size=2>Joe, Congrad on one year at your job. It has indeed 
been filled with events. As you say, I dont have any desire to meet with 
reporters so decline the request. Let us let Craig have the last word. As we 
know nothing is as it appears to be.&nbsp; All the best and keep in touch.&nbsp; 
Arnie</FONT></DIV></BODY></HTML>

--Boundary_(ID_Z89BO7EQwDd9hm13hABaCQ)--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:18'!
exampleBadMessage368Skeleton
	"answer the message stream.  This is a message that fails to parse as of 6/25/07."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadMessage368Skeleton)"

	^(ReadWriteStream with:
'From: "Yates" <kycm@earthlink.net>
To: <whizzer@mail.tulane.edu>
Subject: WSNY event-Oct 30
Date: Thu, 25 Oct 2001 09:20:19 -0400
Message-ID: <000001c15d57$cc57ab40$a7b3f4d1@janelley>
Importance: Normal
MIME-Version: 1.0
Content-Type: multipart/related;
	boundary="----=_NextPart_000_0001_01C15D36.454791E0_E2mX"

This is a multi-part message in MIME format.

------=_NextPart_000_0001_01C15D36.454791E0_E2mX
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_0001_01C15D36.454791E0"

------=_NextPart_000_0001_01C15D36.454791E0
Content-Type: text/html;

<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" 

</html>

------=_NextPart_000_0001_01C15D36.454791E0_E2mX--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:21'!
exampleBadMessage3Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because it
	 has parenses within the boundary string that the parser confuses with comments.
	 Fixed as of 1/16/08"
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage3Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <lain@midway.utam.edu>
Received: from midway.utam.edu (midway.utam.edu [134.128.12.12])
	by mail.utx.edu (8.11.6/8.11.6) with ESMTP id g0OJDVa03534
	for <frucrok@mail.utx.edu>; Thu, 24 Jan 2002 14:13:31 -0500 (EST)
Received: from pc-xu500 (hhmi-pc10.bsd.utam.edu [134.128.170.204])
	by midway.utam.edu (8.11.6/8.11.6) with ESMTP id g0OJDUd22403;
	Thu, 24 Jan 2002 13:13:30 -0600 (CST)
Message-Id: <4.2.0.58.20020124131941.00aa4a60@acs-popmail.utam.edu>
X-Sender: lain@acs-popmail.utam.edu
X-Mailer: QUALCOMM Windows Eudora Pro Version 4.2.0.58 
Date: Thu, 24 Jan 2002 13:22:04 -0500
To: Nancy Blough <frucrok@mail.utx.edu>
From: Ellen Frees <lain@midway.utam.edu>
Subject: Re: UTX Univ. announcing your joining us!!
Cc: Alice Lessig <lessiga@utx.edu>
In-Reply-To: <a0510037ab87522596987@[129.85.16.86]>
X-UIDL: O:o"!!ohS!!!!hDC"!!d[P!!!!
Mime-Version: 1.0
Content-Type: multipart/alternative;
	boundary="=====================_16831203==_.ALT"

This is a multi-part message in MIME format.

--=====================_16831203==_.ALT
--=====================_16831203==_.ALT
Content-Type: text/html;

<html>
<font size=3>Dear Nancy,<br>
<br>
February 1 draft should be fine. I expect to be in town, and will be able
to turn around a draft quickly. Either Feb 8 or Feb 22 should be fine as
a publication date.
<br>
With best regards,<br>
<br>
Ellen<br>
<br>
At 09:35 PM 1/23/02 -0500, you wrote:<br>
<blockquote type=cite cite><blockquote type=cite cite>Dear Ellen, thanks
for your e-mail with an update about HHMI.&nbsp; Great
news!!</blockquote><br>
<br>
I actually had e-mailed you earlier - but it bounced back. Here is it,
with some updates from me IN ALL CAPS.<br>
<br>
Warm regards, Nancy<br>
<br>
<blockquote type=cite cite>Date: Wed, 23 Jan 2002 11:32:14 -0500 (EST)<br>
From: Mail Delivery Subsystem &lt;MAILER-DAEMON&gt;<br>
To: &lt;frucrok@mail.utx.edu&gt;<br>
Subject: Returned mail: see transcript for details<br>
Auto-Submitted: auto-generated (failure)<br>
<br>
The original message was received at Wed, 23 Jan 2002 11:32:12 -0500 (EST)<br>
 from gallaghm-pc.utx.edu [129.85.16.86]<br>
<br>
&nbsp;&nbsp; ----- The following addresses had permanent fatal errors
-----<br>
&lt;lain@acs-popmail.utam.edu&gt;<br>
&nbsp;&nbsp;&nbsp; (reason: 550 5.0.0 Access denied)<br>
<br>
Date: Wed, 23 Jan 2002 11:32:05 -0500<br>
To: lain@plaisance.utam.edu<br>
From: Nancy Blough &lt;frucrok@mail.utx.edu&gt;<br>
Subject: UTX&nbsp; campus newspaper &amp; news release about your
joining<br>
&nbsp;university<br>
Cc: lessiga@mail.utx.edu<br>
--=====================_16831203==_.ALT
Content-Type: text/plain; charset=&quot;us-ascii&quot; ;
format=&quot;flowed&quot;<br>
<br>
Dear Ellen:<br>
<br>
Hi!!&nbsp; Thanks for asking about status of our news release and campus
newspaper story about your announcement.<br>
<br>
ELAINE, WE MIGHT WANT TO ASSUME THAT WE''LL ANNOUNCE FOR FEB. 22ND
ISSUE.&nbsp; IF WE SEND DRAFT TO YOU ON FEB. 1, ONLY WAY WE CAN PUBLISH
ON FEB. 8 IS IF OUR DRAFT IS PERFECT FOR YOU.&nbsp; DRAFTS AT THIS STAGE
RARELY ARE PERFECT!!!!!!<br>
<br>
<blockquote type=cite cite><br>
Ideally, we should issue a news release with the same embargo date as the
campus newspaper.<br>
<br>
What are the best dates for publication for your personal schedule? (to
give you time to review draft(s) and to be available for interviews with
selected reporters -- you''ll recall our approach is to arrange for you
and other top scientists to talk with only the best and brightest of
journalists.)<br>
<br>
We''re so excited about your joining Univ TX -- and so soon!!!!!!<br>
<br>
Best regards, Nancy<br>
<br>
--<br>
Nancy Blough<br>
Vice President, Communications<br>
Univ TX<br>
212-327-7121<br>
frucrok@mail.utx.edu</blockquote><br>
<br>
-- <br>
Nancy Blough<br>
Vice President, Communications<br>
UTX University<br>
212-327-7121<br>
frucrok@mail.utx.edu<br>
</font></blockquote><br>
<div>Ellen Frees, Ph.D.</div>
<div>Biogen Professor of Basic Sciences</div>
<div>Department of Molecular Genetics and Cell Biology</div>
<div>The University of Texas</div>
</html>

--=====================_16831203==_.ALT--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:24'!
exampleBadMessage428Skeleton
	"answer the message stream.  This is a message that fails to parse as of 6/25/07."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadMessage428Skeleton)"

	^(ReadWriteStream with:
'From: "Tomson, Gregg" <gregg.tomson@ril.com>
To: "''breck@mail.uncw.edu''" <breck@mail.uncw.edu>
Cc: "''gtomson@aol.com''" <gtomson@aol.com>
Message-Id: <E31FC649F02CD411A77C00062957077A039842@BRESRPN1>
Subject: david
Date: Wed, 7 Nov 2001 12:12:40 -0500 
MIME-Version: 1.0
Content-Type: multipart/related; boundary="----_=_NextPart_001_01C167AF.67F965A0_E2mX"

This is a multi-part message in MIME format.

------_=_NextPart_001_01C167AF.67F965A0_E2mX
Content-Type: multipart/alternative; boundary="----_=_NextPart_001_01C167AF.67F965A0"

------_=_NextPart_001_01C167AF.67F965A0
Content-Type: text/html;

<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word"

<head>

</html>

------_=_NextPart_001_01C167AF.67F965A0_E2mX--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:47'!
exampleBadMessage43Skeleton
	"Answer the message stream.  This message failed to parse as of 2/20/08 because it has a message/external-body bodypart."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage43Skeleton)"

	^(ReadWriteStream with:
'From rool@mail.ccul.edu Fri Feb 15 14:25:34 2008
Return-Path: <rool@mail.ccul.edu>
Received: from [129.85.16.98] (brenerk-mac.ccul.edu [129.85.16.98])
	by mail.ccul.edu (8.11.6/8.11.6) with ESMTP id f98LIss01945
	for <barker>; Mon, 8 Oct 2001 17:18:55 -0400 (EDT)
Message-Id: <l0313030ab7e7c7088cfd@[129.85.16.98]>
Date: Mon, 8 Oct 2001 17:18:51 -0400
To: barker
From: Art Rool <rool@mail.ccul.edu>
Subject: CCR5 Q&A
X-UIDL: 3k2"!!Pgf!!!!#WT!!!!-IM!!!!
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary="============_-1209546564==_============"
X-Folder: mbox

This is a multi-part message in MIME format.

--============_-1209546564==_============
Content-Type: text/plain; charset="iso-8859-1"

Dear Art: Just a quick update: Ive got the "Q" part of the Q&A down

--============_-1209546564==_============
Content-Disposition: attachment
Content-Type: multipart/appledouble;
	boundary=============_-1209546564==_============_E2mXatt


--============_-1209546564==_============_E2mXatt
Content-Type: message/external-body;
	access-type=local-file;
	name="Attach\Q+A Schering C"

Content-Disposition: attachment;
	filename="Q&A study"
Content-Transfer-Encoding: base64
Content-Type: application/applefile;
	name="Q&A study"

--============_-1209546564==_============_E2mXatt
Content-Type: message/external-body;
	access-type=local-file;
	name="Attach\Q+A study[1]"

Content-Disposition: attachment;
	filename="Q&A study"
Content-Type: application/octet-stream;
	name="Q&A study"
Content-Transfer-Encoding: base64

--============_-1209546564==_============_E2mXatt--

--============_-1209546564==_============--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:50'!
exampleBadMessage4Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because it
	 has bad non-unicode chars."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmalParserExamples exampleBadMessage4Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <mumbl@mail.wheeland.edu>
Received: from [129.85.45.55] (mill6.wheeland.edu [129.85.45.55])
	by mail.wheeland.edu (8.12.5/8.12.5) with ESMTP id g7FEAw0W001708;
	Thu, 15 Aug 2002 10:10:59 -0400 (EDT)
User-Agent: Microsoft-Entourage/10.1.0.2006
Date: Thu, 15 Aug 2002 10:12:52 -0400
Subject: FW: 
From: Fernando Cortez <mumbl@mail.wheeland.edu>
To: <bonnerj>
CC: <yurthc>
Message-ID: <B9812F24.7C1%mumbl@mail.wheeland.edu>
In-Reply-To: <B945D499.61C%mumbl@mail.wheeland.edu>
X-UIDL: [>J!!!!CJJ!!!!9mf!!!!6~V"!!
Mime-version: 1.0
Content-type: multipart/mixed; boundary="B_3112251172_57034"

This is a multi-part message in MIME format.

--B_3112251172_57034
--B_3112251172_57034
Content-Type: text/html;

<HTML>
<HEAD>
<TITLE>FW: </TITLE>
</HEAD>
<BODY>
<FONT FACE="Geneva">Joe,<BR>
<BR>
Here is the second copy sent to Cathy, &nbsp;Not sure where the<BR>
Confusion is, but hopefully it is not to late to make certain<BR>
that Dr. Cortez&#8217;s submission is as originally requested.<BR>
Thanks.<BR>
<BR>
<BR>
------ Forwarded Message<BR>
<B>From: </B>Fernando Cortez &lt;mumbl@mail.wheeland.edu&gt;<BR>
<B>Date: </B>Mon, 01 Jul 2002 09:42:46 -0400<BR>
<B>To: </B>Mark Yurthugh &lt;yurthc@mail.wheeland.edu&gt;<BR>
<B>Subject: </B>&lt;no subject&gt;<BR>
<BR>
</FONT><FONT FACE="Verdana">Dear Mark,<BR>
Please find attached the updated SEP for Dr. Cortez&#8217;s lab, as well as the<BR>
Field Center. &nbsp;I believe a couple of pictures were also included. &nbsp;This &nbsp;was sent to 

<BR>
you in April.<BR>
<BR>
Pat Tellerday<BR>
</FONT><FONT FACE="Geneva">------ End of Forwarded Message<BR>
</FONT>
</BODY>
</HTML>


--B_3112251172_57034
Content-Type: text/plain;


"FRC copy for SEP[1] 1" (missing attachment)
      ¨  ê                           

          "               Ä          
   I  
  T  
   e     1            

                       popM   (    ®    ¼ÄI    ¼Å.     ¼Å.     B            s      

   fee@rain.com    M i c h e l e   F e e      D                             
 

  Î                &    r q      L   &                                  

 
     
     X  µ  jtext/plainiso-8859-1      L   %                          

         	     
     ñ  Ú  ¯text/htmliso-8859-1multipart/alternative    ^          

  s         
mumbl@mail.wheeland.edu   $ F e r n a n d o   C o r t e z 

m00b701c243dc$b84cc420$d1550387@science.rain.com

Re: <no subject>  ¿  ú ®    ù ®  
--B_3112251172_57034--

--B_3112251172_57034--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:51'!
exampleBadMessage5Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because it
	 has an illegal timeZone, GMT flanked by double quotes."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage5Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <info@acfoundation.org>
Received: from lv0.net (host2.colaterica.com [64.235.128.4] (may be forged))
	by mail.blah.edu (8.11.6/8.11.6) with ESMTP id g4ULIoh29542
	for <yarbroc@mail.blah.edu>; Thu, 30 May 2002 17:18:50 -0400 (EDT)
Message-Id: <200205302118.g4ULIoh29542@mail.blah.edu>
Received: from lv-web001 (lv-web001.localvoice.com)
	by lv0.net (LSMTP for Windows NT v1.1b)
	with SMTP id <0.000BF59F@lv0.net>; Thu, 30 May 2002 14:18:47 -0700
From: Samantha <info@acfation.org>
To: somebody <who@mail.blah.edu>
Date: Thu, 30 May 2002 21:18:46 "GMT"
X-MSMail-Priority: Normal
Reply-To: info@acfation.org
X-mailer: AspMail 3.02 (QSMT18F01E)
Subject: Donation Receipt from Foundation
Content-Transfer-Encoding: 7bit
X-UIDL: `TY!!!!YM;"!!2`<!!!!ZNj"!!
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"

                        ** Please Do NOT Reply to this E-mail **

') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 13:53'!
exampleBadMessage63Skeleton
	"answer the message stream.  This message fails to parse as of 6/25/07"
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage63Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <Melissa.Mars@prsa.org>
Received: from localhost by walt1 with LMTP for <mmph@imap.jrandom.edu>; Mon, 03 May 2004 15:41:57 -0400
Received: from mail1.publicaster.com (mail3.publicaster.com [65.111.81.197])
	for <mmph@mail.jrandom.edu>; Mon, 3 May 2004 15:41:54 -0400 (EDT)
Message-Id: <200405031941.i43Jfsnn018541@smtp2.jrandom.edu>
Date: Mon, 3 May 2004 15:41:02 -0400
X-SENDER: systems@blueskyfactory.com
Subject: PRSA Health Academy newsletter
From: "Melissa.Mars@prsa.org" <Melissa.Mars@prsa.org>
To: mmph@mail.jrandom.edu
Content-Type: multipart/mixed; boundary="outerBoundary667"

This is a multi-part message in MIME format.

--outerBoundary667
Content-Type: text/plain; charset="iso-8859-1"

--outerBoundary667
--outerBoundary667
Content-Type: multipart/alternative; boundary="innerBoundary6672"

--innerBoundary6672
--outerBoundary667
Content-Type: text/plain; charset="iso-8859-1"

Dear Health Academy Member:

The latest Academy member newsletter is now available for viewing.

--boundary10715096672
--boundary1071509667
Content-Type: text/html

<P>Bunch of html 

--innerBoundary6672--

--outerBoundary667--
--outerBoundary667--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 14:00'!
exampleBadMessage6Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because it
	 has an illegal timeZone, GMT flanked by double quotes."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage6Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <betty@whoknows.org>
Received: from smtp03.mrf.mail.rcn.net (smtp03.mrf.mail.rcn.net [207.172.4.62])
	by mail.blah.edu (8.11.6/8.11.6) with ESMTP id g2LFOnR09022
	for <gerber@blah.edu>; Thu, 21 Mar 2002 10:24:49 -0500 (EST)
X-Info: This message was accepted for relay by
	smtp03.mrf.mail.rcn.net as the sender used SMTP authentication
X-Trace: UmFuZG9tSVZyI5wwCyo0xzREkmzG0ftTj6IEKlWOlbqDxvq22ldg3amQ
Received: from dca-30-b-29.dca.dsl.cerfnet.com ([63.242.165.29] helo=glorpist.org)
	by smtp03.mrf.mail.rcn.net with asmtp (Exim 3.33 #10)
	id 16o4QU-0003Ov-00; Thu, 21 Mar 2002 10:24:26 -0500
Message-ID: <3C99F9AC.AD40456A@glorpist.org>
Date: Thu, 21 Mar 2002 10:18:04 -0500
From: Betty <betty@whoknows.org>
Organization: Canadian for Medical Progress Educational Foundation
X-Mailer: Mozilla 4.78 [en] (Win98; U)
X-Accept-Language: en
Subject: March 23 Public Affairs Forum
Content-Transfer-Encoding: 7bit
Bcc:
X-UIDL: WL]"!!F@#!![?H"!!?d%#!!
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii

Dear Colleague,

We have had a tremendous response for the public affairs forum to be
held THIS
Saturday, March 23, from 1:00 pm to 6:00 pm at the Massachusetts Medical Society.  We are looking forward to an informative
and stimulating meeting.  Please see below for directions to the
meeting.

We look forward to seeing you on Saturday.

Canadian for Medical Progress

     Massachusetts Medical Society
     640 Winter Street
     Waltham Woods Corporate Center
     Waltham, MA 04251-1611


###########################################################
###########################################################
#####
#####
###########################################################
###########################################################

') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 14:01'!
exampleBadMessage7Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because
	 the ContentType boundary parameter misparsed with its name being ';boundary'."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage7Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <lookd@oberlin.edu>
Received: from dlook-pc.kansas.edu (persnl-pc6.kansas.edu [129.85.27.181])
	by mail.kansas.edu (8.11.6/8.11.6) with ESMTP id g0IMC6F15046;
	Fri, 18 Jan 2002 17:12:06 -0500 (EST)
Message-Id: <5.1.0.14.0.20020118160418.029b1ec0@depvax.kansas.edu>
X-Sender: lookd@depvax.kansas.edu
X-Mailer: QUALCOMM Windows Eudora Version 5.1
Date: Fri, 18 Jan 2002 16:15:10 -0500
To: undisclosed-recipients@mail.kansas.edu
From: dan look <lookd@kansas.edu>
Subject: TIAA-CREF Seminar on January 29, 2002
X-UIDL: VRm"!!,H2!!!!H39!!!!:5L"!!
Mime-Version: 1.0
Content-Type: multipart/related;
	type="multipart/alternative";
	boundary="=====================_86070711==_.REL"

This is a multi-part message in MIME format.

--=====================_86070711==_.REL
--=====================_86070711==_.REL
Content-Type: text/html;

<html>
<div align="center"><font size=4>Mark Your Calendar for<br><br>
</font><font size=4 color="#0000FF"><b>Tuesday, January 29, 2002 at 12
pm<br>
110B Nurses Residence<br><br>
TIAA-CREF</b></font><font size=4> will be on campus<br>
to conduct a seminar entitled<br><br>
</font><font size=4 color="#0000FF"><b>&quot;How Do I Allocate My Monies
Among all of the TIAA-CREF Funds?&quot;<br><br>
</b></font><img src="cid:5.1.0.14.0.20020118160418.029b1ec0@depvax.kansas.edu.0" width=128 

height=128 alt="4ec420f.jpg"></b><br><br>
</div>
<font size=4>It''s never too soon to start saving for your retirement and
other investment goals. TIAA-CREF can help you understand savings and
investment strategies that are right for you.<br><br>
Please join us and become familiar with:</font>
<ul>
<li>TIAA-CREF investment choices
<li>Asset allocation strategies
<li>Allocation changes and transferring accumulations
<li>Discussion of inflation and risk
</ul><font size=4>You are welcome to bring your lunch.<br><br>
Questions?&nbsp; Please call Human Resources at ext. 8300.<br><br>
We hope to see you there!!!!</font></html>


--=====================_86070711==_.REL
Content-Type: image/jpeg;
	name="4ec420f.jpg"
Content-Transfer-Encoding: base64
Content-ID: <filelist.xml@01C19543.C0B63A80>

/9j/4AAQSkZJRgABAQAAAQABAAD/2wBDAAEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEB
AQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQH/2wBDAQEBAQEBAQEBAQEBAQEBAQEBAQEB
L5ALaBLWARLfXVyIRHbRQ26iHywYILeIgpBCqa9Ff4+ZxxlxXxBTqUM64jznMsNVqxrTweKzHEzw
Ptad/Z1I4H2iwcJQ5pcjhQjyXfLa5/NXEfiR4gcX0quG4n404nz3B1sQsVPL8yzvMMRlirqUpwqU
ssnX/s+i6bk/ZKjhqcaMbRpKEUkiiiivmz4oKKKKAP/Z

--=====================_86070711==_.REL--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 14:24'!
exampleBadMessage8Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because
	 the ContentType boundary parameter is encoded as HTML and hence unreadable."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage8Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <blessme@mail.moloc.edu>
Received: from develop01.mail.moloc.edu (blessme-pc.moloc.edu [129.85.23.154])
	by mail.moloc.edu (8.12.5/8.12.5) with ESMTP id g9IH1F01019959;
	Fri, 18 Oct 2002 13:01:15 -0400 (EDT)
Message-Id: <5.1.0.14.0.20021018125827.03544ad0@mail.moloc.edu>
X-Sender: blessme@mail.moloc.edu
X-Mailer: QUALCOMM Windows Eudora Version 5.1
Date: Fri, 18 Oct 2002 13:01:00 -0400
To: arbrok
From: Martha Blessbach <blessme@mail.moloc.edu>
Subject: Fwd: RE: Oct. 22 - Book Party - Town & Country
Cc: imhoff, smithk, ruc
X-UIDL: P/I"!!hIg"!!+!!C"!!UH$!!!!
Mime-Version: 1.0
Content-Type: multipart/alternative;
	boundary="=====================_-501030894==_.ALT"

This is a multi-part message in MIME format.

--=====================_-501030894==_.ALT
--=====================_-501030894==_.ALT
Content-Type: text/html;

<html>
Dear Marnie<br><br>
FYI - Here is Alice''s email about Mike.&nbsp; And please
see attached below, a message I just received from her saying that he''ll
be bringing a photographer with him.<br><br>
Lisa<br><br>
<blockquote type=cite class=cite cite>From: &quot;Victor, Alice S.&quot;
&lt;avictor@rockco.com&gt;<br>
To: &quot;''Martha Blessbach ''&quot;
&lt;blessme@mail.moloc.edu&gt;,<br>
&nbsp;&nbsp; &quot;Pillsbury, Marnie S.&quot;
&lt;mpillsbury@rockco.com&gt;,<br>
&nbsp;&nbsp; &quot;Johnson, Peter J.&quot;<br>
<x-tab>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</x-tab>&lt;pjohnson@rockco.com&gt;<br>
Cc: &quot;''imhoff@mail.moloc.edu ''&quot;
&lt;imhoff@mail.moloc.edu&gt;,<br>
&nbsp;&nbsp; &quot;''smithk@mail.moloc.edu ''&quot;
&lt;smithk@mail.moloc.edu&gt;,<br>
&nbsp;&nbsp; &quot;''ruc@mail.moloc.edu ''&quot;
&lt;ruc@mail.moloc.edu&gt;<br>
Subject: RE: Oct. 22 - Book Party - Remarks, Photographer, &amp;
Books<br>
Date: Tue, 15 Oct 2002 17:58:57 -0400<br>
X-Mailer: Internet Mail Service (5.5.2653.19)<br><br>
<font size=2>&nbsp;Lisa - I''m putting this on paper, so I can remember I
did it......</font> <br>
<font size=2>Another photographer coming is Mike, from
Town&amp;Country, and I think someone from my area called you with his
name for the list.&nbsp; Marnie P. and PJ &quot;approved&quot; this some
time ago.&nbsp; T&amp;C is doing an article on Gates Philanthropy
for their Jan issue, and he has been talking to Brook
Rock.&nbsp; He wants a group shot, and Brook (and I) have told him
firmly &quot;NO&quot;.&nbsp; He can take individual candids of members
and put together a collage for the article, but absolutely
nothing staged.&nbsp; Brook has agreed to monitor him the whole time
he is there.&nbsp; I just hope that works.&nbsp; <br>
</font><br>
<font size=2>alice</font> <br>
</blockquote><br>
From: &quot;Victor, Alice S.&quot; &lt;avictor@rockco.com&gt;<br>
To: &quot;''Martha Blessbach''&quot;
&lt;blessme@mail.moloc.edu&gt;<br>
Subject: RE: Oct. 22 - Book Party - Press Response<br>
Date: Fri, 18 Oct 2002 12:45:38 -0400<br>
MIME-Version: 1.0<br>
X-Mailer: Internet Mail Service (5.5.2653.19)<br>
--=====================_-501030894==_.ALT
Content-Type: multipart/alternative;<br>
<x-tab>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</x-tab>boundary=&quot;----_=_NextPart_001_01C276C5.C9EBBDA0&quot;<br>
X-UIDL: i6&quot;&quot;!!Ge4&quot;!!Op0!!!!W=e&quot;!!<br><br>
<font face="arial" size=2 color="#0000FF">Lisa -<br>
</font>&nbsp;<br>
<font face="arial" size=2 color="#0000FF">please add Julie Skarratt to
this list.&nbsp; It seems Mike is a top editor at
Town&amp;Country, and Julie is the photographer.&nbsp; <br>
</font>&nbsp;<br>
<font face="arial" size=2 color="#0000FF">Many thanks<br>
alice</font>
<dl><font face="tahoma" size=2>
<dd>-----Original Message-----
<dd>From:</b> Martha Blessbach
[<a href="mailto:blessme@mail.moloc.edu" 

eudora="autourl">mailto:</a>blessme@mail.moloc<a href="mailto:blessme@mail.moloc.edu" 

eudora="autourl">.edu</a>]
<dd>Sent:</b> Thursday, October 17, 2002 7:30 PM
<dd>To:</b> arbrok@mail.moloc.edu
<dd>Cc:</b> mpillsbury@relco.com; pjohnson@relco.com;
avictor@relco.com; imhoff@mail.moloc.edu;
smithk@mail.moloc.edu; ruc@mail.moloc.edu
<dd>Subject:</b> Oct. 22 - Book Party - Press Response<br><br>
</font>
<dd>Dear Marnie<br><br>

<dd>Here is a status report on the press invited to the party:<br><br>

<dd>Attending</b>
<dd>Tom Brokaw, NBC News - per his assistant Sara, &quot;he will definitely stop by&quot;
<dd>Mike, Town &amp; Country
<dd>Bill Cunningham, NY Times - plans to come by for a shot early in the evening
<dd>Diana Henriques, NY Times
<dd>Robert Lenzner, Forbes
<dd>Carol Loomis, Fortune
<dd>Charlie Rose, PBS<br><br>

<dd>Still Outstanding</b>
<dd>Robert Bartley, Wall Street Journal
<dd>Howell Raines, NY Times
<dd>Stephanie Strom, NY Times
<dd>Julie Salomon, Wall Street Journal<br><br>

<dd>Declined</b>
<dd>Barbara Walters - she will be in Tennessee<br><br>

<dd>You will forward this to Fraser, right?&nbsp; I don''t have an email
address for him.&nbsp; 
<dd>I''ll give you a call if we get in more replies in tomorrow.&nbsp;
<br><br>

<dd>Lisa <br><br>

</dl></html>

--=====================_-501030894==_.ALT--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 14:28'!
exampleBadMessage9Skeleton
	"Answer the message stream.  This message failed to parse as of 1/16/08 because
	 of unbalanced parens in header comments, but now parses as of 2/28/08."
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmailParserExamples exampleBadMessage9Skeleton)"

	^ (ReadWriteStream with:
'Return-Path: <childep@cambridge.edu>
Received: from cambridge.edu (bonnerj8-mac.cambridge.edu [129.85.16.107])
	by mail.cambridge.edu (8.12.5/8.12.5) with ESMTP id g72KZe0W006048
	for <bolus@cambridge.edu>; Fri, 2 Aug 2002 16:35:41 -0400 (EDT)
Message-ID: <3D4AED1A.C6F80CB7@cambridge.edu>
Date: Fri, 02 Aug 2002 16:35:37 -0400
From: Patricia Child <childep@cambridge.edu>
Reply-To: childep@cambridge.edu
Organization: Cambridge University
X-Mailer: Mozilla 4.78 (Macintosh; U; PPC)
X-Accept-Language: en
To: Blevin <blevbok@cambridge.edu>
Subject: [Fwd: Images from shaka for guidebook - original TIFFs]
X-UIDL: \Z-"!!Yk,#!!I<D"!!A~N!!!!
MIME-Version: 1.0
Content-Type: multipart/mixed;
 boundary="------------2D607C7928EF52DECF26347E"

This is a multi-part message in MIME format.

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain; charset="iso-8859-1"



-------- Original Message --------
Subject: Images from shaka for guidebook - original TIFFs
Date: Mon, 29 Jul 2002 12:24:55 -0700 (PDT)
From: Tshaka Cunningham <shakac@yahoo.com>
Reply-To: shakac@alumni.princeton.edu
To: childep@cambridge.edu, Wensica.Evo-Devo@cambridge.edu

Wensica,

Here are the images that you asked for.  They are in
the original TIFF file format, straight from the
microscope.  Good luck with the guidebook.  

Cheers,

Shaka

(2-messages will follow with the other images)


__________________________________________________
Do You Yahoo!!?
Yahoo!! Health - Feel better, live better
http://health.yahoo.com
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff;
 name="Macrophage with normal HIV day21.tif"
Content-Description: Macrophage with normal HIV day21.tif
Content-Disposition: inline;
 filename="Macrophage with normal HIV day21.tif"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophage with normal HIV day2" (missing attachment)
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff; x-mac-type="54494646"; x-mac-creator="4A565752";
 name="Macrophage with D116A HIV day 2"
Content-Description: Unknown Document
Content-Disposition: inline;
 filename="Macrophage with D116A HIV day 2"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophage with D116A HIV day 2" (missing attachment)
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff; x-mac-type="54494646"; x-mac-creator="4A565752";
 name="Macrophage with D116A HIV-7"
Content-Description: Unknown Document
Content-Disposition: inline;
 filename="Macrophage with D116A HIV-7"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophage with D116A HIV-7" (missing attachment)
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff; x-mac-type="54494646"; 

x-mac-creator="4A565752";
 name="Macrophage with normal HI-3"
Content-Description: Unknown Document
Content-Disposition: inline;
 filename="Macrophage with normal HI-3"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophage with normal HI-3" (missing attachment)
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff; x-mac-type="54494646"; x-mac-creator="4A565752";
 name="Macrophage with normal HIV day2"
Content-Description: Unknown Document
Content-Disposition: inline;
 filename="Macrophage with normal HIV day2"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophage with normal HIV da 1" (missing attachment)
--------------2D607C7928EF52DECF26347E
Content-Type: image/tiff; x-mac-type="54494646"; 

x-mac-creator="4A565752";
 name="Macrophages without HIV (contro"
Content-Description: Unknown Document
Content-Disposition: inline;
 filename="Macrophages without HIV (contro"

--------------2D607C7928EF52DECF26347E
Content-Type: text/plain;


"Macrophages without HIV (contro" (missing attachment)
--------------2D607C7928EF52DECF26347E--
') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 15:03'!
exampleBadMessageBigHTML
	"Answer the message stream.  This message failed to parse as of 7/28/08."
	"RFC2822MIMEMessage new parseFromStream: (EmailParserExamples exampleBadMessageBigHTML)"

	^(ReadWriteStream with:
'From: "Wheaton, Kristen" <WheatonK@ubs.edu>
Sender: "Wheaton, Kristen" <WheatonK@ubs.edu>
To: "Mounty, Python" <MountyV@ubs.edu>
Subject: Re: Fw: allocation of additional funds to existing IAG
Date: Fri, 4 Mar 2005 15:19:55 -0400
Message-ID: <F3E4E8823C8B4146A0BAC5E10FC2A1038A062C@IT-ECL02.US.ITNET.UBS.EDU>
MIME-Version: 1.0
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_17898_01C8ECDD.89115080"
X-Mailer: Microsoft Office Outlook 11
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.3198

This is a multi-part message in MIME format.

------=_NextPart_000_17898_01C8ECDD.89115080
Content-Type: text/plain;
	charset="Windows-1252"
Content-Transfer-Encoding: 7bit

just to clarify...you will prepare a written request to UPS with this
information.  we can go over it if you wish, first.  otherwise,
just draft a letter with the detail attached.


(See attached file: UPS_Butts IATPlan.xls)


(See attached file: 799209 Plan FY 06.xls)
(See attached file: 799209 Plan FY 06.xls)

------=_NextPart_000_17898_01C8ECDD.89115080
Content-Type: text/html;
	charset="Windows-1252"
Content-Transfer-Encoding: quoted-printable

<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
charset=3DWindows-1252">
<META NAME=3D"Generator" CONTENT=3D"MS Exchange Server version =
6.5.7036.0">
<TITLE>Re: Fw: allocation of additional funds to existing IAG</TITLE>
</HEAD>
<BODY>
<!!-- Converted from text/plain format -->

<P><FONT SIZE=3D2>just to clarify...you will prepare a written request =
to UPS with this information.&nbsp; we can go over it if you =
wish, first.&nbsp; otherwise, just draft a letter with the detail =
attached.</FONT></P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; Python Mounty 03/03/05 04:02PM =
&gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Karl,</FONT>
</P>

<P><FONT SIZE=3D2>Thanks.&nbsp; We will take it from here.</FONT>
</P>

<P><FONT SIZE=3D2>Python</FONT>
</P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; &lt;Butts.Karl@upsmail.ups.gov&gt; =
03/03/05 03:38PM &gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Sorry about that Python,</FONT>
</P>

<P><FONT SIZE=3D2>One more try...</FONT>
</P>

<P><FONT SIZE=3D2>As stated before, no additional funds were added for =
next year for</FONT>

<BR><FONT SIZE=3D2>travel or other supplies.&nbsp; I will continue to =
draw from funds that</FONT>

<BR><FONT SIZE=3D2>remain for travel and supplies and will request that =
UPS add additional</FONT>

<BR><FONT SIZE=3D2>funds at a later date if necessary.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks,</FONT>

<BR><FONT SIZE=3D2>Karl</FONT>
</P>

<P><FONT SIZE=3D2>(See attached file: Plan final2 2005-2006 FY =
06.xls)</FONT>

<BR><FONT SIZE=3D2>----- Forwarded by Karl Butts/DC/USUPS/US on =
03/03/2005 03:30 PM -----</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
Karl&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
sp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
Butts/DC/USUPS/US&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; To </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; 03/02/2005 =
05:13&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Python Mounty =
&lt;MountyP@ubs.edu&gt; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
PM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp; cc </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Kristen Wheaton &lt;KRISTENW@OSP.UBS.EDU&gt;,&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Bleven =
Farley&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; =
&lt;kfortier@crc.ubs.edu&gt;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp; Subject </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Re: Fwd: Re: allocation =
of&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; additional funds to existing IAG&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; (Document link: Karl Butts)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>
</P>
<BR>
<BR>

<P><FONT SIZE=3D2>Python,</FONT>
</P>

<P><FONT SIZE=3D2>Here is the latest budget.&nbsp; Any additional funds =
for travel or supplies</FONT>

<BR><FONT SIZE=3D2>were not included.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks,</FONT>

<BR><FONT SIZE=3D2>Karl</FONT>
</P>
<BR>
<BR>
<BR>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; Python =
Mounty&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Karl =
Butts/DC/USUPS/US@UPS&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
PM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Bleven =
Farley&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>


<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Wheaton =
&lt;KRISTENW@OSP.UBS.EDU&gt;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
 </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Re: Fwd: Re: allocation =
of&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; additional funds to existing IAG&nbsp; </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
</FONT>
</P>
<BR>
<BR>
<BR>

<P><FONT SIZE=3D2>Karl,</FONT>
</P>

<P><FONT SIZE=3D2>Sounds good!!</FONT>
</P>

<P><FONT SIZE=3D2>We look forward to hearing from the UPS grants =
office.&nbsp; Please keep us</FONT>

<BR><FONT SIZE=3D2>updated.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks,</FONT>

<BR><FONT SIZE=3D2>Python</FONT>
</P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; &lt;Butts.Karl@upsmail.ups.gov&gt; =
02/17/05 11:57AM &gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Thanks Python,</FONT>
</P>

<P><FONT SIZE=3D2>I will pass the new numbers on to my management here =
at UPS...</FONT>

<BR><FONT SIZE=3D2>Karl</FONT>
</P>
<BR>
<BR>
<BR>
<BR>

<P><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; Python Mounty</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; &lt;MountyP@ubs.edu </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Karl Butts/DC/USUPS/US@UPS</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; 02/17/2005 =
11:27&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
sp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp; cc</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
AM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Bleven =
Farley</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; &lt;kfortier@crc.ubs.edu&gt;, Kristen</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Wheaton &lt;KRISTENW@OSP.UBS.EDU&gt;</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Re: Fwd: Re: allocation of</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; additional funds to existing IAG</FONT>
</P>
<BR>
<BR>
<BR>
<BR>
<BR>
<BR>
<BR>
<BR>
<BR>

<P><FONT SIZE=3D2>Karl,</FONT>
</P>

<P><FONT SIZE=3D2>Thank you, and you are welcome.</FONT>
</P>

<P><FONT SIZE=3D2>Based on what you wrote below, it does seem that your =
next trip and</FONT>

<BR><FONT SIZE=3D2>step</FONT>

<BR><FONT SIZE=3D2>increase should be around September and October 2005, =
so I changed the</FONT>

<BR><FONT SIZE=3D2>so that your budget for FY 2006 =
(10/1/05-9/30/06) is based on a</FONT>

<BR><FONT SIZE=3D2>GS</FONT>

<BR><FONT SIZE=3D2>(3%).</FONT>

<BR><FONT SIZE=3D2>&nbsp;The increase should be effective in the first =
period in calendar</FONT>

<BR><FONT SIZE=3D2>year</FONT>

<BR><FONT SIZE=3D2>2006.&nbsp; The revised is attached.</FONT>
</P>

<P><FONT SIZE=3D2>The difference in the as a result of the above =
change is not</FONT>

<BR><FONT SIZE=3D2>great</FONT>

<BR><FONT SIZE=3D2>(approximately), but it is best to be as =
accurate as possible.</FONT>
</P>

<P><FONT SIZE=3D2>Sincerely,</FONT>

<BR><FONT SIZE=3D2>Python Mounty</FONT>

<BR><FONT SIZE=3D2>Office of Sponsored Projects</FONT>

<BR><FONT SIZE=3D2>303-555-0961</FONT>
</P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; &lt;Butts.Karl@upsmail.ups.gov&gt; =
02/16/05 05:26PM &gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Python,</FONT>
</P>

<P><FONT SIZE=3D2>Thanks for the information and summary.&nbsp; After I =
spoke with you this</FONT>

<BR><FONT SIZE=3D2>morning I checked the Federal Personnel Guide on-line =
and under the step</FONT>

<BR><FONT SIZE=3D2>increase section it states that they are dependent on =
waiting periods</FONT>

<BR><FONT SIZE=3D2>(see page 32 of the Federal Personnel Guide).&nbsp; =
It is my understanding</FONT>

<BR><FONT SIZE=3D2>that step increases take place annually (every 52 =
weeks) from one''s</FONT>

<BR><FONT SIZE=3D2>start date for the first 4 steps.&nbsp; Last year my =
annual trip took place</FONT>

<BR><FONT SIZE=3D2>in August or Sept and then the step increase was in =
October.&nbsp; I just</FONT>

<BR><FONT SIZE=3D2>want to be sure to get the increase at the =
correct time, rather</FONT>

<BR><FONT SIZE=3D2>than wait an extra 6 months if it is not =
necessary.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks again for all of your help and quick =
responses,</FONT>

<BR><FONT SIZE=3D2>Karl</FONT>
</P>
<BR>
<BR>
<BR>
<BR>

<P><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; Python Mounty</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; &lt;MountyP@ubs.edu </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
&gt;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
sp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; To</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Karl Butts/DC/USUPS/US@UPS</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; 02/16/2005 =
12:43&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
sp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp; cc</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; =
PM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Bleven =
Farley</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; &lt;kfortier@crc.ubs.edu&gt;, Kristen</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Wheaton &lt;KRISTENW@OSP.UBS.EDU&gt;</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Fwd: Re: allocation of additional</FONT>

</P>
<BR>
<BR>

<P><FONT SIZE=3D2>Karl,</FONT>
</P>

<P><FONT SIZE=3D2>It was nice to talk to you this morning.</FONT>
</P>

<P><FONT SIZE=3D2>To summarize:</FONT>
</P>

<P><FONT SIZE=3D2>You are prupsring a memo to send to the head of the =
office there at UPS.</FONT>
</P>

<P><FONT SIZE=3D2>The memo will contain the amounts needed to fund your =
position and</FONT>

<BR><FONT SIZE=3D2>project</FONT>

<BR><FONT SIZE=3D2>expenses in FY 2006.&nbsp; Once the funding is =
approved, the UPS grants</FONT>

<BR><FONT SIZE=3D2>office</FONT>

<BR><FONT SIZE=3D2>will contact the Office of Sponsored Projects so we =
can work with them</FONT>


increased it to a GS 14/3</FONT>

<BR><FONT SIZE=3D2>effective beginning in the first pay period in 2006 =
(1/8/06). I also</FONT>

<BR><FONT SIZE=3D2>increased it by a cost-of-living rate of 4%.&nbsp; =
The cost-of-living</FONT>

<BR><FONT SIZE=3D2>increase is</FONT>

<BR><FONT SIZE=3D2>also effective beginning in the first pay period in =
2006.&nbsp; (Step</FONT>

<BR><FONT SIZE=3D2>increases</FONT>

<BR><FONT SIZE=3D2>and cost-of-living increases generally are effective =
in the first pay</FONT>

<BR><FONT SIZE=3D2>period</FONT>

<BR><FONT SIZE=3D2>in a new calendar year.)</FONT>
</P>

<P><FONT SIZE=3D2>Funds from an interagency agreement may be expended =
during the budget</FONT>

<BR><FONT SIZE=3D2>period only.&nbsp; The period for the most =
recent agreement is 10/1/04</FONT>

<BR><FONT SIZE=3D2>through 9/30/05.</FONT>
</P>

<P><FONT SIZE=3D2>Please remember that OSP is responsible for submitting =
the requests for</FONT>

<BR><FONT SIZE=3D2>interagency agreements, so please contact us if there =
is going to be</FONT>

<BR><FONT SIZE=3D2>another</FONT>

<BR><FONT SIZE=3D2>interagency agreement so we can contact the UPS =
project officer.</FONT>
</P>

<P><FONT SIZE=3D2>Please let me know if you need anything else at the =
moment.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks,</FONT>

<BR><FONT SIZE=3D2>Python Mounty</FONT>

<BR><FONT SIZE=3D2>Oregonian Institution</FONT>

<BR><FONT SIZE=3D2>Office of Sponsored Projects</FONT>

<BR><FONT SIZE=3D2>303-555-0001</FONT>

</P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; &lt;Butts.Karl@upsmail.ups.gov&gt; =
02/15/05 10:29AM &gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Kristen,</FONT>
</P>

<P><FONT SIZE=3D2>Thanks for the quick reply and your help.</FONT>

<BR><FONT SIZE=3D2>Please do not hesitate to contact me with any =
questions.</FONT>
</P>

<P><FONT SIZE=3D2>Karl</FONT>
</P>
<BR>
<BR>
<BR>
<BR>

<P><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; Kristen Wheaton</FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp; &lt;KRISTENO@OSP.SI.E </FONT>

<BR><FONT =
SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
&nbsp;&nbsp; Karl Butts/DC/USUPS/US@UPS</FONT>

<P><FONT SIZE=3D2>Karl: thank you for your inquiry.&nbsp; Python =
Mounty of my staff is going</FONT>

<BR><FONT SIZE=3D2>to</FONT>

<BR><FONT SIZE=3D2>look at the spreadsheet and see if he can get you the =
answers you need.</FONT>

<BR><FONT SIZE=3D2>He</FONT>

<BR><FONT SIZE=3D2>will be in touch with you.&nbsp; Please note that =
either myself or Python are</FONT>

<BR><FONT SIZE=3D2>your</FONT>

<BR><FONT SIZE=3D2>contacts to replace Jerry at this point. =
thanks.</FONT>
</P>

<P><FONT SIZE=3D2>&gt;&gt;&gt; &lt;Butts.Karl@upsmail.ups.gov&gt; =
02/14/05 12:19PM &gt;&gt;&gt;</FONT>

<BR><FONT SIZE=3D2>Dear Stephen,</FONT>
</P>

<P><FONT SIZE=3D2>I am currently on an IAG with the UPS in a term =
position that began</FONT>

<BR><FONT SIZE=3D2>October 1, 2004.&nbsp; Jersey Pole was formerly =
handling the for</FONT>

<BR><FONT SIZE=3D2>this agreement, but I understand that it is now under =
Stephen Smith.</FONT>
</P>

<P><FONT SIZE=3D2>My office here at the UPS is considering putting some =
funds that they</FONT>

<BR><FONT SIZE=3D2>currently have into my IAG for next year (starting =
October 1, 2005).</FONT>

<BR><FONT SIZE=3D2>They would like a somewhat accurate calculation of =
what the number</FONT>

<BR><FONT SIZE=3D2>should be that will go to the SI for the =
agreement.&nbsp; I think it is okay</FONT>

<BR><FONT SIZE=3D2>to keep basically the same as last year, but =
was wondering if you</FONT>

<BR><FONT SIZE=3D2>could calculate in the cost of living increase and =
any step increase</FONT>

<BR><FONT SIZE=3D2>that I might qualify for.&nbsp; Then I can give them =
a number on what funds</FONT>

<BR><FONT SIZE=3D2>to set</FONT>

<BR><FONT SIZE=3D2>aside to cover the IAG for 2005-2006.</FONT>
</P>

<P><FONT SIZE=3D2>I have one other question.&nbsp; What happens to money =
that I do not use this</FONT>

<BR><FONT SIZE=3D2>year (for example the $2000 for US Domestic travel? =
or the $500 for</FONT>

<BR><FONT SIZE=3D2>supplies).&nbsp; Will it be transferred to next year, =
or is it lost if not</FONT>

<BR><FONT SIZE=3D2>used?</FONT>
</P>

<P><FONT SIZE=3D2>Attached is the Jersey provided me with last =
year.</FONT>
</P>

<P><FONT SIZE=3D2>Thanks for any help you can provide,&nbsp; please do =
not hesitate to contact</FONT>

<BR><FONT SIZE=3D2>me if you have any questions.</FONT>
</P>

<P><FONT SIZE=3D2>Kind regards,</FONT>

<BR><FONT SIZE=3D2>Karl Butts</FONT>
</P>

<P><FONT SIZE=3D2>(See attached file: UPS_Butts IATPlan.xls)</FONT>
</P>

<P><FONT SIZE=3D2>Karl Butts, PhD</FONT>

<BR><FONT SIZE=3D2>Office of Science Coordination and Policy</FONT>

<BR><FONT SIZE=3D2>US UPS</FONT>

<BR><FONT SIZE=3D2>202-564-8478</FONT>

<BR><FONT SIZE=3D2>(See attached file: UPS_Butts IATPlan.xls)</FONT>
</P>
<BR>

<P><FONT SIZE=3D2>(See attached file: 799209 Plan FY 06.xls)</FONT>

<BR><FONT SIZE=3D2>(See attached file: 799209 Plan FY 06.xls)</FONT>
</P>

</BODY>
</HTML>
------=_NextPart_000_17898_01C8ECDD.89115080--

') reset! !

!EmailParserExamples class methodsFor: 'example problem messages' stamp: 'SLB 8/13/2008 15:05'!
exampleBadTonyMessage704Skeleton
	"answer the message stream.  This message fails to parse as of 6/25/07"
	"(RFC2822MIMEMessage relativePath: './Steves parser test/Inbox') parseFromStream: (EmalParserExamples exampleBadTonyMessage704Skeleton)"

	^(ReadWriteStream with:
'Return-Path: <tony@bumphu.edu>
Received: from localhost by walt1 with LMTP for <bebrok@bumphu.edu>; Tue, 17 Aug 2004 09:09:41 -0400
Received: from [129.85.129.27] (lb.bumphu.edu [218.111.54.8])
	by smtp1.bumphu.edu (Switch-3.1.6/Switch-3.1.6) with ESMTP id i7HD9fRJ000099
	for <bebrok@mail.bumphu.edu>; Tue, 17 Aug 2004 09:09:41 -0400 (EDT)
Message-ID: <412203F4.5010603@bumphu.edu>
Date: Tue, 17 Aug 2004 09:11:16 -0400
From: Anthony Nowicz <tony@mail.bumphu.edu>
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.1) Gecko/20040707
To: Corrine Bebrok <brok@mail.bumphu.edu>
Subject: Re: [Fwd: Lower Ohio Conference 2004 Awards]
References: <41211BDF.5030807@bumphu.edu> <a05100301bd47a292bcad@[129.85.131.163]>
In-Reply-To: <a05100301bd47a292bcad@[129.85.131.163]>
MIME-Version: 1.0
Content-Type: multipart/alternative;
 boundary="------------050008050806050205050502"

This is a multi-part message in MIME format.

--------------050008050806050205050502
--------------050008050806050205050502
Content-Type: text/html;

<!!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
  <meta content="text/html;charset=ISO-8859-1" http-equiv="Content-Type">
  <title></title>
</head>
<body bgcolor="#ffffff" text="#000000">
  <blockquote type="cite" cite=""><tt>--<br>
    <br>
----------------------------------------------------------------------<br>
Return-Path: <a class="moz-txt-link-rfc2396E" href="mailto:godnuf@bumphu.edu">&lt;godnuf@bumphu.edu&gt;</a><br>
Received: from localhost by walt1 with LMTP; Mon, 16 Aug 2004 15:16:29
-0400<br>
Received: from smtp1.bumphu.edu with LMTP by walt1
(3.0.1/sieved-3-0-build-541);<br>
    <x-tab> </x-tab>Mon, 16 Aug 2004 15:16:29 -0400<br>
Received: from GOODNOUGH-PC.bumphu.edu (lb.bumphu.edu
[218.111.54.8])<br>
    <x-tab>&nbsp; </x-tab>by smtp1.bumphu.edu
(Switch-3.1.6/Switch-3.1.6) with ESMTP id i7GJGSa8004819;<br>
    <x-tab>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </x-tab>Mon, 16 Aug 2004
15:16:28 -0400 (EDT)<br>
Message-Id:
<a class="moz-txt-link-rfc2396E" href="mailto:5.1.0.14.2.20040816151117.02999970@imap.bumphu.edu">&lt;5.1.0.14.2.20040816151117.02999970@imap.bumphu.edu&gt;</a><br>
X-Sender: <a class="moz-txt-link-abbreviated" href="mailto:godnuf@imap.bumphu.edu">godnuf@imap.bumphu.edu</a><br>
X-Mailer: QUALCOMM Windows Eudora Version 5.1<br>
Date: Mon, 16 Aug 2004 15:16:26 -0400<br>
To: <a class="moz-txt-link-abbreviated" href="mailto:tony@bumphu.edu">tony@bumphu.edu</a>, <a class="moz-txt-link-abbreviated" href="mailto:mikem@bumphu.edu">mikem@bumphu.edu</a>,
<a class="moz-txt-link-abbreviated" href="mailto:gale@bumphu.edu">gale@bumphu.edu</a><br>
From: Norine Anon <a class="moz-txt-link-rfc2396E" href="mailto:godnuf@mail.bumphu.edu">&lt;godnuf@mail.bumphu.edu&gt;</a><br>
Subject: Lower Ohio Conference 2004 Awards<br>
Mime-Version: 1.0<br>
--------------050008050806050205050502
Content-Type: multipart/alternative;<br>
    <x-tab>&nbsp;&nbsp;
    </x-tab>boundary="=====================_23599718==_.ALT"<br>
  </blockquote>
  <blockquote type="cite" cite=""><font face="Times New Roman"><b><br>
LOWER OHIO CONFERENCE OCTOBER 12<font size="-2">th</font> ANNUAL
MEETING<br>
WILL HONOR 2004s REGIONAL AWARDS FOR EXCELLENCE WINNERS<br>

for the exhibition and educational program The Ideal and The Real, an
</body>
</html>

--------------050008050806050205050502--
') reset! !
